/*
 * static char *rcsid_button_c =
 *   "$Id: button.c,v 1.1.1.1 1993/03/07 08:31:17 frankj Exp $";
 */

/*
    CrossFire, A Multiplayer game for X-windows

    Copyright (C) 1992 Frank Tore Johansen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The author can be reached via e-mail to frankj@ifi.uio.no.
*/

/*
 * This code is highly inefficient, I'll improve it in the future by
 * building a linked list of button between all connected objects.
 */

#include <global.h>

void push_button(object *op) {
  int x,y;
  object *tmp;
  for(x=0;x<op->map->mapx;x++)
    for(y=0;y<op->map->mapy;y++)
      if((tmp=get_map_ob(op->map,x,y))!=NULL&&tmp->stats.sp==op->stats.sp)
        switch(tmp->type) {
        case GATE:
        case HOLE:
          tmp->value=tmp->stats.maxsp?!op->value:op->value,tmp->speed=0.5;
          break;
        case HANDLE:
          tmp->face=tmp->arch->faces[tmp->value=
                    tmp->stats.maxsp?!op->value:op->value];
          update_object(tmp);
          break;
        case ALTAR:
          if (!tmp->value) {
            tmp->value =  tmp->stats.maxsp ? !op->value : op->value;
            tmp->face = tmp->arch->faces[tmp->value];
            update_object(tmp);
          }
          break;
        case BUTTON:
        case PEDESTAL:
         tmp->value=op->value;
         tmp->face=tmp->arch->faces[tmp->value];
         update_object(tmp);
         break;
       }
}

void update_button(object *op) {
  object *ab,*tmp;
  int tot,x,y,any_down=0;
  for(x=0;x<op->map->mapx;x++)
    for(y=0;y<op->map->mapy;y++)
      if((tmp=get_map_ob(op->map,x,y))!=NULL) {
        if (tmp->type==BUTTON && tmp->stats.sp==op->stats.sp) {
        for(ab=tmp->above,tot=0;ab!=NULL;ab=ab->above)
          if(!IS_FLYING(ab)) /* Why is nrof removed? */
            tot+=ab->weight*(ab->nrof?ab->nrof:1)+ab->carrying;
        tmp->value=(tot>=tmp->weight)?1:0;
        if(tmp->value)
          any_down=1;
        } else if (tmp->type == PEDESTAL && tmp->stats.sp==op->stats.sp) {
          tmp->value = 0;
          for(ab=tmp->above; ab!=NULL; ab=ab->above) {
            if(ab->head!=NULL)
              ab=ab->head;
            if ( (!IS_FLYING(ab) || FLY_ON(tmp)) && (ab->race==tmp->slaying ||
                 (!strcmp (tmp->slaying, "player") && ab->type == PLAYER)))
              tmp->value = 1;
      }
          if(tmp->value)
            any_down=1;

        }
      }
  if(any_down) /* If any other buttons were down, force this to remain down */
    op->value=1;
  op->face=op->arch->faces[op->value];
  update_object(op);
  push_button(op); /* Make all other buttons the same */
}

void update_buttons(mapstruct *m) {
  int x,y;
  object *op;
  for(x=0;x<m->mapx;x++)
    for(y=0;y<m->mapy;y++)
      for(op=get_map_ob(m,x,y);op!=NULL;op=op->above)
        if(op->type==BUTTON || op->type==PEDESTAL)
          update_button(op);
}
