/*
 * static char *rcsid_info_c =
 *    "$Id: info.c,v 1.1.1.1 1993/03/07 08:31:17 frankj Exp $";
 */

/*
    CrossFire, A Multiplayer game for X-windows

    Copyright (C) 1992 Frank Tore Johansen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The author can be reached via e-mail to frankj@ifi.uio.no.
*/

#include <global.h>

/*
 * The functions in this file are purely mean to generate information
 * in differently formatted output, mainly about monsters.
 */

void dump_abilities() {
  archetype *at;
  for(at = first_archetype; at; at=at->next) {
    char *ch;
    if(!IS_MONSTER(&at->clone))
      continue;
    ch = describe_item(&at->clone);
    printf("%-16s|%6d|%s\n",at->clone.name,at->clone.stats.exp,ch);
  }
}

void print_monsters() {
  archetype *at;
  object *op;
  char   attbuf[32], protbuf[32], immbuf[32], vulnbuf[32];

  printf("               |     |   |    |    |      attack       |    protected      |     immune        |    vulnerable     |        |         |\n");
  printf("monster        | hp  |dam| ac | wc |pmf ecw adw gpd ptf|pmf ecw adw gpd ptf|pmf ecw adw gpd ptf|pmf ecw adw gpd ptf|  exp   | new exp |\n");
  printf("---------------------------------------------------------------------------------------------------------------------------------------\n");
  for(at=first_archetype;at!=NULL;at=at->next) {
    op = arch_to_object(at);
    if (IS_MONSTER(op)) {
      bitstostring((long)op->attacktype, 15, attbuf);
      bitstostring((long)op->protected, 15, protbuf);
      bitstostring((long)op->immune, 15, immbuf);
      bitstostring((long)op->vulnerable, 15, vulnbuf);
      printf("%-15s|%5d|%3d|%4d|%4d|%s|%s|%s|%s|%8d|%9d|\n",
        op->arch->name, op->stats.maxhp, op->stats.dam, op->stats.ac,
        op->stats.wc,
        attbuf, protbuf, immbuf, vulnbuf, op->stats.exp, new_exp(op));
    }
    free_object(op);
  }
}

void bitstostring(bits, num, str)
long    bits;
int     num;
char    *str;
{
  int   i,j=0;

  if (num > 32)
    num = 32;

  for (i=0;i<num;i++) {
    if (i && (i%3)==0) {
      str[i+j] = ' ';
      j++;
    }
    if (bits&1)
      str[i+j] = '1';
    else
      str[i+j] = '0';
    bits >>= 1;
  }
  str[i+j] = '\0';
  return;
}
