/*
 * static char *rcsid_edit_h =
 *   "$Id: edit.h,v 1.1.1.1 1993/03/07 08:30:53 frankj Exp $";
 */

/*
    CrossFire, A Multiplayer game for X-windows

    Copyright (C) 1992 Frank Tore Johansen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The author can be reached via e-mail to frankj@ifi.uio.no.
*/

#include <X11/keysym.h>

extern int freearr_x[SIZEOFFREE];
extern int freearr_y[SIZEOFFREE];

extern char colorname[13][MAX_NAME];
extern int itemcolor[][2];

/* The maximum width of the edit-window */
int edit_width=24,edit_height=20;

char *message[20];


#ifdef TWO_BYTES_FONT

#define BG_SIZE 34
#define REAL_WALLS 6
#define ARCH_WALLS 3
#define WALLS 14

XChar2b bg_icons[BG_SIZE]={
   { 0,'p' },
   { 1,79  },
   { 1,143 },
   { 1,95  },
   { 1,111 },
   { 1,127 },
   { 1,191 },
   { 3, 55 },
   { 4, 37 },
   { 1,10  },
   { 1,20  },
   { 4,226 },
   { 4,249 },
   { 5,111 },
   { 0,  0 },
   { 0,  0 },
   { 0,  0 },
   { 0,  0 },
   { 0,  0 },
   { 0,  0 },
   { 0,  0 },
   { 0,  0 },
   { 0,  0 },
   { 0,  0 },
   { 0,  0 },
   { 0,  0 },
   { 0,  0 },
   { 0,  0 },
   { 0,  0 },
   { 0,'\037' },
   { 1  ,4 },
   { 0,245 },
   { 0,G_BLANK }, 
   { 0,'\0'}
   };

static XChar2b walls[WALLS*16] = {
 { 0,'p'}, { 0,'m'}, { 0,'o'}, { 0,'c'}, { 0,'l'}, { 0,'a'}, { 0,'d'},
 { 0,'h'}, { 0,'n'}, { 0,'f'}, { 0,'b'}, { 0,'g'}, { 0,'e'}, { 0,'j'},
 { 0,'i'}, { 0,'k'}, { 1, 79}, { 1, 76}, { 1, 78}, { 1, 66}, { 1, 75},
 { 1, 64}, { 1, 67}, { 1, 71}, { 1, 77}, { 1, 69}, { 1, 65}, { 1, 70},
 { 1, 68}, { 1, 73}, { 1, 72}, { 1, 74}, { 1,143}, { 1,140}, { 1,142},
 { 1,130}, { 1,139}, { 1,128}, { 1,131}, { 1,135}, { 1,141}, { 1,133},
 { 1,129}, { 1,134}, { 1,132}, { 1,137}, { 1,136}, { 1,138}, { 1, 95},
 { 1, 92}, { 1, 94}, { 1, 82}, { 1, 91}, { 1, 80}, { 1, 83}, { 1, 87},
 { 1, 93}, { 1, 85}, { 1, 81}, { 1, 86}, { 1, 84}, { 1, 89}, { 1, 88},
 { 1, 90}, { 1,111}, { 1,108}, { 1,110}, { 1, 98}, { 1,107}, { 1, 96},
 { 1, 99}, { 1,103}, { 1,109}, { 1,101}, { 1, 97}, { 1,102}, { 1,100},
 { 1,105}, { 1,104}, { 1,106}, { 1,127}, { 1,124}, { 1,126}, { 1,114},
 { 1,123}, { 1,112}, { 1,115}, { 1,119}, { 1,125}, { 1,117}, { 1,113},
 { 1,118}, { 1,116}, { 1,121}, { 1,120}, { 1,122}, { 1,191}, { 1,188},
 { 1,190}, { 1,178}, { 1,187}, { 1,176}, { 1,179}, { 1,183}, { 1,189},
 { 1,181}, { 1,177}, { 1,182}, { 1,180}, { 1,185}, { 1,184}, { 1,186},
 { 3, 55}, { 3, 52}, { 3, 54}, { 3, 42}, { 3, 51}, { 3, 40}, { 3, 43},
 { 3, 47}, { 3, 53}, { 3, 45}, { 3, 41}, { 3, 46}, { 3, 44}, { 3, 49},
 { 3, 48}, { 3, 50}, { 4, 47}, { 4, 44}, { 4, 46}, { 4, 34}, { 4, 43},
 { 4, 32}, { 4, 35}, { 4, 39}, { 4, 45}, { 4, 37}, { 4, 33}, { 4, 38},
 { 4, 36}, { 4, 41}, { 4, 40}, { 4, 42}, { 1, 10}, { 1, 11}, { 1, 12},
 { 1, 13}, { 1, 14}, { 1, 15}, { 1, 16}, { 1, 17}, { 1, 18}, { 1, 19},
 { 0, 35}, { 0, 35}, { 0, 35}, { 0, 35}, { 0, 35}, { 0, 35}, { 1, 20},
 { 1, 21}, { 1, 22}, { 1, 23}, { 1, 24}, { 1, 25}, { 1, 26}, { 1, 27},
 { 1, 28}, { 1, 29}, { 0, 35}, { 0, 35}, { 0, 35}, { 0, 35}, { 0, 35},
 { 0, 35}, { 4,226}, { 4,227}, { 4,228}, { 4,229}, { 4,230}, { 4,231},
 { 4,232}, { 4,233}, { 4,234}, { 4,235}, { 4,236}, { 4,237}, { 0, 35},
 { 0, 35}, { 0, 35}, { 0, 35}, { 4,249}, { 4,250}, { 4,251}, { 4,252},
 { 4,253}, { 4,254}, { 4,255}, { 5,  0}, { 5,  1}, { 5,  2}, { 5,  3},
 { 5,  4}, { 5,  5}, { 5,  6}, { 5,  7}, { 0, 35}, { 5,103}, { 5,104},
 { 5,105}, { 5,106}, { 5,107}, { 5,108}, { 5,109}, { 5,110}, { 5,111},
 { 0, 35}, { 0, 35}, { 0, 35}, { 0, 35}, { 0, 35}, { 0, 35}, { 0, 35}
};

#else

#define BG_SIZE 19

static char bg_icons[BG_SIZE]={
  'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p',
  '\037',G_BLANK,'\0'
};

static char walls[16]= {
  'p','m','o','c','l','a','d','h','n','f','b','g','e','j','i','k'
};
#endif

int fix_map=0;

/* #define USE_FILEPATH */
#ifdef USE_FILEPATH
#define NROFBUTTONS 17
#else
#define NROFBUTTONS 16
#endif

#define BUTTON_LOAD 0
#define BUTTON_SAVE 1
#define BUTTON_QUIT 2
#define BUTTON_LEVEL 3
#define BUTTON_MAPX 4
#define BUTTON_MAPY 5
#define BUTTON_STARTX 6
#define BUTTON_STARTY 7
#define BUTTON_NAME 8
#define BUTTON_PREV 9
#define BUTTON_NEXT 10
#define BUTTON_ENTER 11
#define BUTTON_MONSTER 12
#define BUTTON_GENERATOR 13
#define BUTTON_HIDDEN 14
#define BUTTON_OTHERS 15
#define BUTTON_PATH 16

char buttons[NROFBUTTONS][BIG_NAME]={
  "Load","Save","Quit","Level:  0","Width:   ","Height:   ",
  "Start X:   ","Start Y:   ","Map: Unnamed         ",
  "Prev","Next", "Enter","Monsters: 1","Generators: 1","Hidden: 0",
  "Others: 1",
#ifdef USE_FILEPATH
  ,"Path: null            "
#endif
};

char write_buf[MAX_BUF];
int buttons_x[NROFBUTTONS],buttons_y[NROFBUTTONS],buttons_w[NROFBUTTONS];

int bg_posx[BG_SIZE],bg_posy[BG_SIZE];
int bar_items; /* How many items displayed in the archetype scrollbar window */

#define EDIT_OB(xyz)\
	((others&&EDITABLE(xyz)&&!IS_MONSTER(xyz)&&!IS_GENERATOR(xyz)) ||\
	(hidden&&!EDITABLE(xyz)) ||\
	(monsters&&IS_MONSTER(xyz)) ||\
	(generators&&IS_GENERATOR(xyz)))
