/*
 * static char *rcsid_graphics_h =
 *   "$Id: graphics.h,v 1.1.1.1 1993/03/07 08:30:54 frankj Exp $";
 */

/*
    CrossFire, A Multiplayer game for X-windows

    Copyright (C) 1992 Frank Tore Johansen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The author can be reached via e-mail to frankj@ifi.uio.no.
*/

#define G_BLANK 	35	/* '#'    */

/*
 * Used by los:
 */
#define G_BLOCKED	423

/*
 * Have to have this at a high value since I mix G_* with fontindex.
 * *URGH* I know.
 */
#define G_USER_DEFINED  50000

/*
 * used in edit.c:
 */
#define G_EARTHW1 	167	/* '\247' */
#define G_EARTHW2 	168	/* '\250' */
#define G_EARTHW3 	169	/* '\251' */

/*
 * Player characters:
 */
#define G_CHAR1 	65	/* 'A'    */
#define G_CHAR2 	66	/* 'B'    */
#define G_CHAR3 	67	/* 'C'    */
#define G_CHAR4 	68	/* 'D'    */
#define G_NINJA1 	20	/* '\024' */
#define G_NINJA2 	21	/* '\025' */
#define G_NINJA3 	18	/* '\022' */
#define G_NINJA4 	19	/* '\023' */
#define G_SWMAN1 	22	/* '\026' */
#define G_SWMAN2 	23	/* '\027' */
#define G_SWMAN3 	24	/* '\030' */
#define G_SWMAN4 	25	/* '\031' */
#define G_WIZARD1 	133	/* '\205' */
#define G_WIZARD2 	134	/* '\206' */
#define G_WIZARD3 	135	/* '\207' */
#define G_WIZARD4 	136	/* '\210' */
#define G_ELF1 		137	/* '\211' */
#define G_ELF2 		138	/* '\212' */
#define G_ELF3 		139	/* '\213' */
#define G_ELF4 		140	/* '\214' */
#define G_CLERIC1 	153	/* '\231' */
#define G_CLERIC2 	154	/* '\232' */
#define G_CLERIC3 	155	/* '\233' */
#define G_CLERIC4 	156	/* '\234' */
#define G_BARBAR1 	157	/* '\235' */
#define G_BARBAR2 	158	/* '\236' */
#define G_BARBAR3 	159	/* '\237' */
#define G_BARBAR4 	160	/* '\240' */
#define G_PRIEST1	294
#define G_PRIEST2	295
#define G_PRIEST3	296
#define G_PRIEST4	297
#define G_MAGE1		424
#define G_MAGE2		425
#define G_MAGE3		426
#define G_MAGE4		427

#if 0
#define G_GUARD 	59      /* ';'    */
#define G_START 	120	/* 'x'    */
#define G_BULLET 	46	/* '.'    */
#define G_TREASURE 	36	/* '$'    */
#define G_POTION 	33	/* '!'    */
#define G_DRINK 	37	/* '%'    */
#define G_FOOD 		94	/* '^'    */
#define G_FLOOR 	35	/* '#'    */
#define G_POISON 	80	/* 'P'    */
#define G_GENGOB 	77	/* 'M'    */
#define G_GOB1 		78	/* 'N'    */
#define G_GOB2 		79	/* 'O'    */
#define G_BURN1 	117	/* 'u'    */
#define G_BURN2 	118	/* 'v'    */
#define G_BURN3 	119	/* 'w'    */
#define G_FBUL_U 	113	/* 'q'    */
#define G_FBUL_R 	114	/* 'r'    */
#define G_FBUL_D 	115	/* 's'    */
#define G_FBUL_L 	116	/* 't'    */
#define G_FBUL_UR 	113	/* 'q'    */
#define G_FBUL_DR 	114	/* 'r'    */
#define G_FBUL_DL 	115	/* 's'    */
#define G_FBUL_UL 	116	/* 't'    */
#define G_LIGHT_1 	69	/* 'E'    */
#define G_LIGHT_2 	70	/* 'F'    */
#define G_LIGHT_3 	71	/* 'G'    */
#define G_LIGHT_4 	72	/* 'H'    */
#define G_LIGHT_5 	73	/* 'I'    */
#define G_LIGHT_6 	74	/* 'J'    */
#define G_LIGHT_7 	75	/* 'K'    */
#define G_LIGHT_8 	76	/* 'L'    */
#define G_ARROW_1 	82	/* 'R'    */
#define G_ARROW_2 	83	/* 'S'    */
#define G_ARROW_3 	84	/* 'T'    */
#define G_ARROW_4 	85	/* 'U'    */
#define G_ARROW_5 	86	/* 'V'    */
#define G_ARROW_6 	87	/* 'W'    */
#define G_ARROW_7 	88	/* 'X'    */
#define G_ARROW_8 	89	/* 'Y'    */
#define G_ARROW 	29	/* '\035' */
#define G_BOW 		41	/* ')'    */
#define G_DOOR_1 	124	/* '|'    */
#define G_DOOR_2 	45	/* '-'    */
#define G_KEY 		40	/* '('    */
#define G_AMULET 	34	/* '"'    */
#define G_AXE 		93	/* ']'    */
#define G_CLUB 		123	/* '{'    */
#define G_SWORD 	125	/* '}'    */
#define G_MACE 		58	/* ':'    */
#define G_ARMOUR 	91	/* '['    */
#define G_SHIELD 	57	/* '9'    */
#define G_TELE1 	150	/* '\226' */
#define G_TELE2 	151	/* '\227' */
#define G_TELE3 	152	/* '\230' */
#define G_EXIT1 	161	/* '\241' */
#define G_EXIT2 	162	/* '\242' */
#define G_EXIT3 	163	/* '\243' */
#define G_SCROLL 	63	/* '?'    */
#define G_BLOCK 	31	/* '\037' */
#define G_GOLEM1 	176	/* '\260' */
#define G_GOLEM2 	177	/* '\261' */
#define G_SPLINT 	178	/* '\262' */
#define G_EXPLO1 	179	/* '\263' */
#define G_EXPLO2 	180	/* '\264' */
#define G_EXPLO3 	181	/* '\265' */
#define G_BOMB1 	182	/* '\266' */
#define G_BOMB2 	183	/* '\267' */
#define G_BOMB3 	184	/* '\270' */
#define G_BOMB4 	185	/* '\271' */
#define G_COINS 	208	/* '\320' */
#define G_TOMB 		0	/* '0'    */

/* 
 * The MAP definitions will soon be obsolete, they are here just for
 * compability
 */
#define MAP_SHOP 's'
#define MAP_DEVIL 'D'
#define MAP_FOOD '%'
#define MAP_FCHEST 'n'
#define MAP_FWALL 'm'
#define MAP_GNOLL 'N'
#define MAP_OGRE  'O'
#define MAP_ORC    'C'
#define MAP_SCORP 'S'
#define MAP_GRIMREAPER 'G'
#define MAP_TELE   'T'
#define MAP_EXIT   'X'
#define MAP_GENKOBOLD 'K'
#define MAP_BLOCK  '@'
#define MAP_EARTH  '&'
#define MAP_BEHOLDER 'B'
#define MAP_GENSKEL 'W'
#define MAP_GENMOUSE '='
#define MAP_GEM '.'
#endif
