/*
 * static char *rcsid_living_h =
 *   "$Id: living.h,v 1.2 1993/03/12 21:52:53 frankj Exp $";
 */

/*
    CrossFire, A Multiplayer game for X-windows

    Copyright (C) 1992 Frank Tore Johansen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The author can be reached via e-mail to frankj@ifi.uio.no.
*/

static int con_bonus[26]={
  -6,-5,-4,-3,-2,-1,-1,0,0,0,0,1,2,3,4,5,6,8,10,12,14,16,18,20,24,28};
static int int_bonus[26]={
  -10,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6,7,8,10,15,20,30,40,60};
int cha_bonus[26]={
  -80,-70,-60,-50,-40,-30,-25,-20,-15,-10,-8,-5,0,4,8,12,16,20,24,28,32,36,40,
   44,48,50};
int dex_bonus[26]={
  -2,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,3,4,4,4,5,5,5,6};
static float speed_bonus[26]={
  -0.4, -0.4, -0.3, -0.3, -0.2, -0.2, -0.2, -0.1, -0.1, -0.1, -0.05, 0, 0, 0,
  0.05, 0.1, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.8, 1.0, 1.2, 1.5};
int dam_bonus[26]={
  -2,-2,-2,-1,-1,-1,0,0,0,0,0,0,1,1,1,2,2,2,3,3,3,4,4,5,5,6};
int thaco_bonus[26]={
  -2,-2,-1,-1,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,2,3,3,3,4,4,5};
int max_carry[26]={
  2,4,7,11,16,22,29,37,46,56,67,79,92,106,121,137,154,172,191,211,232,254,277,
  301,326,352};
int learn_spell[26]={
  0,0,0,1,2,4,8,12,16,25,36,45,55,65,70,75,80,85,90,95,100,100,100,100,100,
  100};
int cleric_chance[26]={
  100,100,100,100,100,100,100,90,80,70,60,50,45,40,35,30,25,20,15,10,5,0,-5,-10,-15,-20};
int turn_bonus[26]={
  -1,-1,-1,-1,-1,-1,-1,-1,0,0,0,1,1,1,2,2,2,3,3,3,4,4,5,5,6,7};
int fear_bonus[26]={
  3,3,3,3,2,2,2,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
static int levels[11]={
  0,0,1000,2000,4000,8000,16000,32000,64000,125000,250000};

#define STR 0
#define DEX 1
#define CON 2
#define WIS 3
#define CHA 4
#define INT 5

static int classbonus[NROFPFACES][6]={ /* Str, Dex, Con, Wis, Cha, Int */
  { 0, 0, 0, 0, 0, 0},	/* No class */
  { 2, 2, 0,-1,-1,-2},	/* Ninja */
  { 3,-1, 2, 0,-1,-3},	/* Warrior */
  {-2, 1,-2, 2, 0, 3},	/* Wizard */
  {-1, 4,-1,-3, 2, 1},  /* Elf */
  { 1,-1, 0, 3, 1,-1},  /* Cleric */
  { 4, 1, 3,-1,-2,-8},  /* Barbarian */
  { 0, 0,-1, 2, 2, 0},  /* Priest */
  { 0, 1,-1, 1,-3, 2},  /* Mage */
  { 1, 1, 2,-1,-1,-2},  /* Viking */
  { 1, 3, 1,-2, 1,-4}   /* Swashbuckler */
};

int savethrow[100]={
  18,17,16,15,14,14,13,13,12,12,12,11,11,11,11,10,10,10,10, 9,
   9, 9, 9, 9, 8, 8, 8, 8, 8, 8, 7, 7, 7, 7, 7, 7, 7, 6, 6, 6,
   6, 6, 6, 6, 6, 5, 5, 5, 5, 5, 5, 5, 5, 5, 4, 4, 4, 4, 4, 4,
   4, 4, 4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2,
   2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
};

int object_saves[NROFATTACKS][NROFMATERIALS] = {
  /* Paper, Iron, Glass, Leather, Wood, Organic, Stone, Cloth */
  {20, 2,19,10,15, 8, 4,19}, /* Physical */
  {15,17,16,15,16,17,10,16}, /* Magic */
  {20, 7,15,15,18,14, 2,19}, /* Fire */
  {14,17,10, 8, 6,16, 2, 8}, /* Electricity */
  {10, 3,15, 7, 6, 8, 4, 9}, /* Cold */
  {15,15,15,15,15,15, 4,10}, /* Water */
  {18,10, 1,15,14,12, 1,15}, /* Acid */
  { 0, 0, 0, 0, 0, 0, 0, 0}, /* Drain */
  {20,20,20,20,20,20,20,20}, /* Weaponmagic */
  {15,15,15,15,15,15,15,15}, /* Ghosthit */
  { 0, 0, 0, 0, 0, 0, 0, 0}, /* IT */
  { 0, 0, 0, 0, 0, 0, 0, 0}, /* Disease */
  { 0, 0, 0, 0, 0, 0, 0, 0}, /* Paralyze */
  { 0, 0, 0, 0, 0, 0, 0, 0}, /* Turn undead */
  { 0, 0, 0, 0, 0, 0, 0, 0}, /* Fear */
  {15,15, 0,17,17, 0,10,10}, /* Cancellation */
  { 0, 0, 0, 0, 0, 0, 0, 0}  /* Depletion */
};

char attacks[NROFATTACKS][16] = {
  "physical", "magical", "fire", "electricity", "cold", "water",
  "acid", "drain", "weaponmagic", "ghosthit", "poison", "disease",
  "paralyze", "turn undead", "fear", "cancellation", "depletion"
};
