/*
 * static char *rcsid_treasure_h =
 *   "$Id: treasure.h,v 1.3 1993/03/13 17:24:19 frankj Exp $";
 */

/*
    CrossFire, A Multiplayer game for X-windows

    Copyright (C) 1992 Frank Tore Johansen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The author can be reached via e-mail to frankj@ifi.uio.no.
*/

/* List, What type to clone_arch(), max magic, how many */

#define MAXMAGIC 4

#define DIFFLEVELS 14

extern spell spells[];

/* List transition rules:
   first number is difficulty of the map neccesary to make the transition.
   if the difficulty is too low, the second number determines if the
   entry is treated as an unused or a nothing.
   if the number is a 0 it is treated as a nothing.  If the number
   is a 1 the entry is treated as an unused.
   if the nrof is -1, the item will only occur in stores(Yes, gross hack alert)
*/
old_treasure treasure_list[NROF_T][MAX_T]=
{ /* For use in chests */
  { /* List 0 */
    {"goldcoin",0,15},
    {"silvercoin",0,90},
    {"list 2",0,0},
    {"list 2",0,0},
    {"list 2",0,0},
    {"list 2",0,0},
    {"list 2",0,0},
    {"list 2",0,0},
    {"list 3",0,0},
    {"list 3",0,0},
    {"list 3",0,0},
    {"list 3",0,0},
    {"list 3",0,0},
    {"list 3",0,0},
    {"list 4",0,0},
    {"list 4",0,0},
    {"list 5",6,0},
    {"list 6",5,0},
    {"list 6",10,0},
    {"list 8",4,0}
  },
  { /* List 1 */
    {"list 2",0,0},
    {"list 2",0,0},
    {"list 2",0,0},
    {"list 3",0,0},
    {"list 3",0,0},
    {"list 3",0,0},
    {"list 4",0,0},
    {"list 4",0,0},
    {"list 4",0,0},
    {"list 5",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0}
  },
  { /* List 2 (weapons) */
    {"list 10",0,0},
    {"list 11",0,0},
    {"list 12",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0}
  },
  { /* List 3 */
    {"ring_mail",4,0},
    {"plate_mail",4,0},
    {"robe",4,0},
    {"leather_armour",4,0},
    {"full_helmet",2,0},
    {"horned_helmet",1,0},
    {"helmet",2,0},
    {"shield",2,0},
    {"small_shield",1,0},
    {"high_shield",2,0},
    {"scale_mail",4,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0}
  },
  { /* List 4 */
    {"food",0,0},
    {"booze",0,0},
    {"food",0,0},
    {"booze",0,0},
    {"food",0,0},
    {"poison",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0}
  },
  { /* List 5 (shop) */
    {"scroll_new",0,3},
    {"scroll_new",0,2},
    {"scroll_new",0,0},
    {"scroll_new",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"ring",0,0},
    {"book",0,0},
    {"book",0,0},
    {"gem",0,1},
    {"ruby",0,3},
    {"pearl",0,16},
    {"list 9",10,0},
    {"list 9",8,0},
    {"list 9",5,0},
    {"sack",0,0},
    {"unused",0,0}
  },
  { /* List 6 */
    {"goldcoin",0,50},
    {"goldcoin",0,100},
    {"goldcoin",0,150},
    {"goldcoin",0,200},
    {"goldcoin",0,250},
    {"silvercoin",0,250},
    {"silvercoin",0,500},
    {"silvercoin",0,750},
    {"silvercoin",0,1000},
    {"silvercoin",0,1500},
    {"gem",0,1},
    {"gem",0,2},
    {"gem",0,4},
    {"pearl",0,6},
    {"pearl",0,12},
    {"pearl",0,24},
    {"ruby",0,2},
    {"ruby",0,4},
    {"ruby",0,8},
    {"unused",0,0}
  },
  { /* List 7 */
    {"goldcoin",0,6},
    {"silvercoin",0,50},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"list 8",10,0}
  },
  { /* List 8 */
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"list 22",4,0},
    {"list 22",10,0},
    {"list 8",8,0},
    {"list 8",10,0},
    {"list 8",10,0},
    {"list 8",12,0},
    {"list 8",14,1},
    {"list 9",14,1},
    {"list 9",13,1},
    {"list 9",12,0},
    {"list 9",10,0},
    {"list 9",8,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0}
  },
  { /* List 9 (Artifacts) */
    {"nothing",0,0},
    {"bracers_ac",4,0},
    {"bracers_ac",4,0},
    {"mithril_chainmail",4,0},
    {"list 15",14,0},
    {"list 13",13,0},
    {"list 13",7,0},
    {"potion_fire",0,0},
    {"potion_cold",0,0},
    {"potion_heal",0,0},
    {"potion_magic",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0}
  },
  { /* list 10 (missile weapons) */
    {"bow",4,0},
    {"arrow",0,30},
    {"crossbow",4,0},
    {"bolt",0,25},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0}
  },
  { /* list 11 (melee weapons part 1) */
    {"dagger",4,0},
    {"shortsword_2",4,0},
    {"shortsword",4,0},
    {"quarterstaff",4,0},
    {"light_sword",4,0},
    {"falchion",4,0},
    {"sabre",4,0},
    {"sword",4,0},
    {"sword_2",4,0},
    {"sword_3",4,0},
    {"sword_4",4,0},
    {"broadsword",4,0},
    {"broadsword_2",4,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0}
  },
  { /* list 12 (melee weapons part 2) */
    {"club",3,0},
    {"mace",4,0},
    {"mace_2",4,0},
    {"hammer",4,0},
    {"hammer_2",4,0},
    {"stonehammer",3,0},
    {"axe_2",4,0},
    {"axe",4,0},
    {"stoneaxe",3,0},
    {"axe_4",4,0},
    {"axe_3",4,0},
    {"morningstar",4,0},
    {"large_morningstar",4,0},
    {"list 27",0,0}, /* Uncommon weapons */
    {"list 27",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0}
  },
  { /* List 13, more uncommon artifacts */
    {"potion_invulnerability",0,0},
    {"mjoellnir",0,0},
    {"bonecrusher",0,0},
    {"firebrand",0,0},
    {"frostbrand",0,0},
    {"deathbringer",0,0},
    {"dragonslayer",0,0},
    {"skullcleaver",0,0},
    {"demonbane",0,0},
    {"sting",0,0},
    {"levitationboots",0,0},
    {"reflector",0,0},
    {"holy_shield",0,0},
    {"girdle_dam",0,0},
    {"dragon_mail",0,0},
    {"dragon_shield",0,0},
    {"ring_nodrain",0,0},
    {"helmet_of_xrays",0,0},
    {"amulet_lifesave",0,0},
    {"elvenboots",0,0}
  },
  { /* List 14, various magic items, mostly scrolls */
    {"amulet",0,0},
    {"amulet",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"book",0,0},
    {"book",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"scroll_new",0,3},
    {"scroll_new",0,3},
    {"scroll_new",0,3},
    {"scroll_new",0,3},
    {"scroll_new",0,3},
    {"scroll_new",0,3},
    {"scroll_new",0,3},
    {"scroll_new",0,3},
    {"gem",0,1},
    {"pearl",0,8},
    {"ruby",0,2},
    {"list 9",9,0}
  },
  { /* List 15, very uncommon artifacts */
    {"nothing",0,0},
    {"elven_bow",0,0},
    {"helmet_of_brilliance",0,0},
    {"holy_avenger",0,0},
    {"darkblade",0,0},
    {"excalibur",0,0},
    {"stormbringer",0,0},
    {"mournblade",0,0},
    {"defender",0,0},
    {"speedboots",0,0},
    {"girdle_str",0,0},
    {"girdle_con",0,0},
    {"girdle_strcon",0,0},
    {"gauntlets_str",0,0},
    {"gauntlets_dex",0,0},
    {"bracers_dex",0,0},
#ifdef SUPERPOTION
    {"superpotionstr",0,0},
    {"superpotiondex",0,0},
    {"superpotioncon",0,0},
    {"superpotionint",0,0}
#else
    {"gram",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0}
#endif
  },
  { /* List 16 - scrolls */
    {"scroll_new",0,5},
    {"scroll_new",0,4},
    {"scroll_new",0,4},
    {"scroll_new",0,3},
    {"scroll_new",0,3},
    {"scroll_new",0,3},
    {"scroll_new",0,3},
    {"scroll_new",0,2},
    {"scroll_new",0,2},
    {"scroll_new",0,2},
    {"scroll_new",0,2},
    {"scroll_new",0,1},
    {"scroll_new",0,1},
    {"scroll_new",0,1},
    {"scroll_new",0,1},
    {"scroll_new",0,1},
    {"scroll_new",0,1},
    {"prepare_weapon",0,-1},
    {"improve_damage",0,-1},
    {"improve_weight",0,-1}
  },
  { /* List 17 - amulets */
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0}
  },
  { /* List 18 - wands */
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"wand",0,0}
  },
  { /* List 19 - Rings */
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0}
  },
  { /* List 20 - Spellbooks */
    {"book",0,0},
    {"book",0,0},
    {"book",0,0},
    {"book",0,0},
    {"book",0,0},
    {"book",0,0},
    {"book",0,0},
    {"book",0,0},
    {"book",0,0},
    {"book",0,0},
    {"book",0,0},
    {"book",0,0},
    {"book",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0},
    {"nothing",0,0}
  },
  { /* List 21 - gems/pearls/rubies */
    {"unused",0,0},
    {"gem",0,1},
    {"gem",0,2},
    {"gem",0,4},
    {"pearl",0,6},
    {"pearl",0,12},
    {"pearl",0,24},
    {"ruby",0,2},
    {"ruby",0,4},
    {"ruby",0,8},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0}
  },
  { /* List 22 - potions */
    {"unused",0,0},
    {"potionstr",0,0},
    {"potionint",0,0},
    {"potioncha",0,0},
    {"potionwis",0,0},
    {"potioncon",0,0},
    {"potiondex",0,0},
    {"potion_heal",0,0},
    {"potion_magic",0,0},
    {"potion_fire",0,0},
    {"potion_cold",0,0},
    {"potion_invulnerability",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"list 14",0,0},
    {"list 14",0,0},
    {"nothing",0,0},
    {"nothing",0,0}
  },
  { /* List 23 - Random Spells */
    {"scroll",0,0},
    {"scroll",0,0},
    {"scroll",0,0},
    {"wand",0,0},
    {"wand",0,0},
    {"book",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0}
  },
  { /* List 24 - Random Talisman */
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"ring",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"amulet",0,0},
    {"list 9",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0}
  },
  { /* List 25 - Artifacts */
    {"list 13",0,0},
    {"list 13",0,0},
    {"list 15",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0}
  },
  { /* List 26 - Weapons */
    {"unused",0,0},
    {"list 11",0,0},
    {"list 12",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0}
  },
  { /* List 27 - Uncommon weapons */
    {"katana_1", 4, 0},
    {"katana_1", 3, 0},
    {"nunchacu_1", 3, 0},
    {"nunchacu_2", 3, 0},
    {"taifu_1", 3, 0},
    {"shovel_1", 2, 0},
    {"stake",2,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0},
    {"unused",0,0}
  }
};
