/*
 * static char *rcsid_edit_c =
 *   "$Id: edit.c,v 1.2 1993/03/09 06:32:24 frankj Exp $";
 */

/*
    CrossFire, A Multiplayer game for X-windows

    Copyright (C) 1992 Frank Tore Johansen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The author can be reached via e-mail to frankj@ifi.uio.no.
*/

/* Edit a map.  The program isn't supposed to return from this function */

#include <graphics.h>
#include <global.h>
#include <edit.h>
#ifndef LET_ANYONE_EDIT
#include <pwd.h>
#endif
#include "proto.h"

int last_x=0,last_y=0;

char *edit_string(char *cp) {
  FILE *fp;
  char buf[MAX_BUF],*filename=(char *) tempnam(TMPDIR,NULL),*tmp;

  buf[0]='\0';
  if(cp!=NULL) {
    if((fp=fopen(filename,"w"))==NULL) {
      perror("can't open tmp-file.");
      return NULL;
    }
    fprintf(fp,cp);
    fclose(fp);
  }
  sprintf(buf,"%s %s",X_EDITOR,filename);
  system(buf);
  if((fp=fopen(filename,"r"))==NULL) {
    perror("can't open tmp-file.");
    return NULL;
  }
  cp= (char *) malloc(sizeof(char)*VERY_BIG_BUF);
  *cp='\0';
  while(fgets(buf,MAX_BUF,fp)!=NULL) {
    strcat(cp,buf);
  }
  fclose(fp);
  unlink(filename);
  if (buf[strlen(buf)-1] != '\n') /* Did the last line lack a newline? */
    strcat(cp,"\n");
  tmp= (char *) malloc(sizeof(char)*strlen(cp)+1);
  strcpy(tmp,cp);
  free(cp);
  return tmp;
}

void allocate_ecolors(player *p){

  static int i,status;

  if(no_color) {
    p->iscolor=0;
    return;
  }
  p->iscolor = 1;
  p->vis = DefaultVisual(p->gdisp,p->escreen);
  if ( p->vis->class == PseudoColor ){
    p->colormap = DefaultColormap(p->gdisp,p->escreen);
    p->depth = DefaultDepth(p->gdisp,p->escreen);
  }
  else
    p->iscolor = 0;
  if (p->depth > 1){
    for (i=0; i<13; i++){
      status = XLookupColor(p->gdisp,p->colormap, colorname[i],&p->exactcolor,
      &p->discolor[i]);
      if (!status){
        LOG(llevError,"Can't find color.\n");
        p->iscolor = 0;
        break;
      }
      status = XAllocColor(p->gdisp,p->colormap,&p->discolor[i]);
      if (!status){
        LOG(llevError,"Can't allocate colors.\n");
        p->iscolor = 0;
        break;
      }
    }
  }
  else{
     LOG(llevError,"Display %s seems to be black and white.\n",p->name);
     p->iscolor = 0;
  }
}

#if 0
void draw_map_window_bw(player *pl) {
  int x=0,y;
  XChar *buf=(XChar *)CALLOC(edit_width+1,sizeof(XChar));

  if(buf==NULL)
    fatal(OUT_OF_MEMORY);
  buf[edit_width]=FontindexToXChar(0);
  for(y=0;y<pl->emy;y++) {
    for(x=0;x<pl->emx;x++)
      buf[x]=FontindexToXChar(out_of_map(pl->emap,x,y)?G_BLANK:
             get_map(pl->emap,x+pl->edx,y+pl->edy));
    XDRAWIMAGESTRING(pl->gdisp,pl->win_game,pl->gc_game,4,28+24*y,buf,pl->emx);
  }
  CFREE(buf);
}
#endif

/* Eneq(@csd.uu.se): Redid this to use update_edit_square, which seemed more 
   reasonable */
/* Frank: Well, more general, but much slower... */
void draw_map_window_bw(player *pl) {
  int x=0,y;

  for(y=0;y<pl->emy;y++) {
    for(x=0;x<pl->emx;x++) 
      update_edit_square (pl, x+pl->edx, y+pl->edy);
  }
}


void draw_map_window_c(player *pl) {
  int x=0,y,last_f= -1,last_b= -1;
#ifdef BEFORE_PIXMAP
  XChar buf;
#endif
  Fontindex f;

  XSetBackground(pl->gdisp,pl->gc_game,pl->discolor[12].pixel);
  for(y=0;y<pl->emy;y++) {
    for(x=0;x<pl->emx;x++){
#ifdef BEFORE_PIXMAP
      buf=FontindexToXChar(f = out_of_map(pl->emap,x,y)?G_BLANK:
          get_map(pl->emap,x+pl->edx,y+pl->edy));
#else
      f = out_of_map(pl->emap,x,y)?G_BLANK:
          get_map(pl->emap,x+pl->edx,y+pl->edy);
#endif
      if(f>2000) {
        LOG(llevError,"Warning: %d:%d has %d\n",x,y,f);
        f=G_BLANK;
      }
      if(last_f!=pl->discolor[itemcolor[f][0]].pixel)
        XSetForeground(pl->gdisp,pl->gc_game,
                       (last_f=pl->discolor[itemcolor[f][0]].pixel));
      if(last_b!=pl->discolor[itemcolor[f][1]].pixel)
      XSetBackground(pl->gdisp,pl->gc_game,
                     (last_b=pl->discolor[itemcolor[f][1]].pixel));
#ifdef BEFORE_PIXMAP
      XDRAWIMAGESTRING(pl->gdisp,pl->win_game,pl->gc_game,4+x*24,28+24*y,
		       &buf,1);
#else
      draw_face(pl,pl->win_game,pl->gc_game,4+x*24,28+24*y,f);
#endif
    }
  }
}

void draw_edit_map(player *pl) {
  int b,d;

  if(pl->edx==pl->old_edx&&pl->edy==pl->old_edy)
    return;
  XSetForeground(pl->gdisp,pl->gc_game,pl->gforeground);
  XSetBackground(pl->gdisp,pl->gc_game,pl->gbackground);
  if(pl->iscolor)
    draw_map_window_c(pl);
  else
    draw_map_window_bw(pl);
  if(pl->emap->mapx==0)
    return;
  b=2+((24*pl->emx-2)*pl->emx)/pl->emap->mapx;
  if(pl->old_edx>=0) {
    d=(24*pl->emx-2)*pl->old_edx/pl->emap->mapx;
    XClearArea(pl->gdisp,pl->win_game,
               4+d,10+pl->emy*24,b,16,0);
  }
  d=(24*pl->emx-2)*pl->edx/pl->emap->mapx;
  if(pl->iscolor)
    XSetForeground(pl->gdisp,pl->gc_game,pl->discolor[0].pixel);
  XFillRectangle(pl->gdisp,pl->win_game,pl->gc_game,
                 4+d,10+pl->emy*24,b,16);
  b=2+((24*pl->emy-2)*pl->emy)/pl->emap->mapy;
  if(pl->old_edy>=0) {
    d=(24*pl->emy-2)*pl->old_edy/pl->emap->mapy;
    if(d+b>pl->emy*24) d=pl->emy*24-b;
    XClearArea(pl->gdisp,pl->win_game,
                   10+pl->emx*24,4+d,16,b,0);
  }
  d=(24*pl->emy-2)*pl->edy/pl->emap->mapy;
  XFillRectangle(pl->gdisp,pl->win_game,pl->gc_game,
                 10+pl->emx*24,4+d,16,b);
  pl->old_edx=pl->edx,pl->old_edy=pl->edy;
}

int draw_arch_scroll(player *pl,int oy) {
  int items,y,total,maxlength,barlength,scroll,i;
  archetype *at;
  Fontindex biff;
#ifdef BEFORE_PIXMAP
  XChar buf;
#endif

  for(total=0,at=first_archetype;at!=NULL;at=at->next)
    if(EDIT_OB((&at->clone)))
      total++;
  
/* First the items: */

  for(at=first_archetype,items=0;
      at!=NULL&&(!EDIT_OB((&at->clone))||items<pl->archd);at=at->next)
    if(EDIT_OB((&at->clone)))
      items++;
  for(y=oy,bar_items=0;
      at!=NULL&&(!EDIT_OB((&at->clone))||y<pl->ehint.height-48);at=at->next)
  {
    if(!EDIT_OB((&at->clone)))
      continue;
    if (pl->iscolor){
      biff = at->clone.face;
      XSetForeground(pl->gdisp,pl->gc_game,
        pl->discolor[itemcolor[biff][0]].pixel);
      XSetBackground(pl->gdisp,pl->gc_game,
        pl->discolor[itemcolor[biff][1]].pixel);
    }
#ifdef BEFORE_PIXMAP
    buf = FontindexToXChar(at->clone.type==EARTHWALL ? G_EARTHW3 : 
			   at->clone.face);
    XDRAWIMAGESTRING(pl->gdisp,pl->win_game,pl->gc_game,
                     pl->emx*24+48,y+24,&buf,1);
#else
    draw_face(pl,pl->win_game,pl->gc_game,pl->emx*24+48,y+24,
              at->clone.type == EARTHWALL ? G_EARTHW3 : at->clone.face);
#endif
    XDrawImageString(pl->gdisp,pl->win_game,pl->etext,pl->emx*24+80,y+12,
                     at->name,(i=strlen(at->name))>17?17:i);
    XDrawImageString(pl->gdisp,pl->win_game,pl->etext,
                     pl->emx*24+80+strlen(at->name)*8,y+12,
                     "                    ",17-(i>17?17:i));
    items++,bar_items++;
    y+=24;
  }
/* Then the scrollbar: */

  maxlength=y-oy+2;
  barlength=(bar_items*maxlength)/total+20;
  if(last_bard)
    XClearArea(pl->gdisp,pl->win_game,pl->emx*24+232,last_bard,16,barlength,0);
  else
    XClearArea(pl->gdisp,pl->win_game,pl->emx*24+232,oy,16,maxlength,0);
  
  scroll=(pl->archd*(maxlength-barlength))/(total-bar_items),
  XSetForeground(pl->gdisp,pl->gc_game,pl->gforeground);
  XFillRectangle(pl->gdisp,pl->win_game,pl->gc_game,
                 pl->emx*24+232,oy+scroll,16,barlength);
  last_bard=oy+scroll;
  return y;
}

int get_wall_type(int w) {
  int i,j;

  if(w==G_BLANK)
    return -1;
  for(i=0;i<WALLS;i++)
    for(j=0;j<16;j++)
      if(XCharToFontindex(walls[i*16+j])==w)
        return i;
  return -1;
}

int get_wall_nr(int w) {
  int i,j;

  if(w==G_BLANK)
    return -1;
  for(i=0;i<WALLS;i++) {
    if(i>=REAL_WALLS&&i<REAL_WALLS+ARCH_WALLS)
      continue;
    for(j=0;j<16;j++)
      if(XCharToFontindex(walls[i*16+j])==w)
        return j;
  }
  return -1;
}

void update_walls(player *pl, int x, int y, int rx, int ry) {
  int i,m=0,w,f;
  Fontindex fin;
  if(!fix_map)
    return;
  f=get_omap(pl->emap,x,y)==G_BLANK?0:1;
  for(i=1;i<9;i+=2) {
    int r=(i-1)/2+2,dx=x+freearr_x[i],dy=y+freearr_y[i],d,d2;
    if(r>3) r-=4;
    d=1<<r;
    r+=2;
    if(r>3) r-=4;
    d2=1<<r;
    if(!out_of_map(pl->emap,dx,dy)) {
      int n,t=get_wall_type(get_omap(pl->emap,dx,dy));
      if(t==-1)
        continue;
      w=get_wall_nr(get_omap(pl->emap,dx,dy));
      n=f?w|d:w&~d;
      if(f)
        m|=d2;
      fin=XCharToFontindex(walls[n+t*16]);
      set_omap(pl->emap,dx,dy,fin);
      set_map(pl->emap,dx,dy,fin);
      update_edit_square(pl,dx,dy);
    }
  }
  if(f) {
    int t=get_wall_type(get_omap(pl->emap,x,y));
    set_omap(pl->emap,x,y,XCharToFontindex(walls[m+t*16]));
    set_map(pl->emap,x,y,XCharToFontindex(walls[m+t*16]));
    update_edit_square(pl,x,y);
  }
}

void update_wall_sel(player *pl) {
  int i;
  for(i=0;i<15;i++)
    bg_icons[WALLS+i]=walls[pl->ewall*16+1+i];
}

void update_edit_square(player *pl,int x, int y) {
#ifdef BEFORE_PIXMAP
  XChar buf;
#endif
  Fontindex f;

  if((x>=pl->emx+pl->edx)||x<pl->edx||y>=(pl->emy+pl->edy)||y<pl->edy)
    return;
  f=out_of_map(pl->emap,x,y)?G_BLANK:get_map(pl->emap,x,y);
#ifdef BEFORE_PIXMAP
  buf=FontindexToXChar(f);
#endif
  if (pl->iscolor){
    XSetForeground(pl->gdisp,pl->gc_game,pl->discolor[itemcolor[f][0]].pixel);
    XSetBackground(pl->gdisp,pl->gc_game,pl->discolor[itemcolor[f][1]].pixel);
  }
#ifdef BEFORE_PIXMAP
  XDRAWIMAGESTRING(pl->gdisp,pl->win_game,pl->gc_game,
                   4+24*(x-pl->edx),28+24*(y-pl->edy),&buf,1);
#else
  draw_face(pl,pl->win_game,pl->gc_game,4+24*(x-pl->edx),28+24*(y-pl->edy),f);
#endif
}

void remove_ob_from_editor(player *pl,object *op) {
  archetype *at;
  if(op->head) {
    remove_ob_from_editor(pl,op->head);
    return;
  }
  remove_ob(op);
  for(at=op->arch;at!=NULL;at=at->more)
    update_edit_square(pl,op->x+at->clone.x,op->y+at->clone.y);
  free_object(op);
}

void mouse_click(player *pl, int x, int y, int button) {
  int i,mx=(x-4)/24,my=(y-4)/24,moved=0,buffered=0;
  Fontindex biff;
  if(button>6)
    buffered=1,button-=3;
  if(button>3)
    moved=1,button-=3;
#if 0
  XSetForeground(pl->gdisp,pl->gc_game,pl->gforeground);
  XSetBackground(pl->gdisp,pl->gc_game,pl->gbackground);
#endif
  if(mx>=0&&mx<pl->emx&&my>=0&&my<pl->emy) {
    object *op;
    object *opa;

    if(moved&&button==3&&pl->earchselect==NULL)
      return;
    if(button_flag==1) { /* Set new start-coordinates */
      int dx=pl->edx,dy=pl->edy;
      pl->emap->startx=mx+pl->edx,pl->emap->starty=my+pl->edy;
      update_vars(pl); /* This is overkill...I'm just lazy... */
      pl->edx=dx,pl->edy=dy;
      refresh_edit(pl);
      button_flag=0;
      return;
    } else if (button_flag == 2) { /* Enter an exit */
      object *op;
      button_flag=0;
      for(op=get_map_ob(pl->emap,mx+pl->edx,my+pl->edy);op!=NULL;op=op->above)
        if(op->type==STAIR||op->type==EXIT||op->type==TELEPORTER)
        {
          int next_level=op->stats.food, old_level=maplevel;
          if(next_level == -1) {
            LOG(llevError,"That exit is closed.\n");
            return;
          }
          if(next_level == pl->emap->level) {
            LOG(llevError,"The exit leads to the same level.\n");
            return;
          }
          maplevel = next_level;
          if(load_edit_map(pl,1)) {
            LOG(llevError,"Failed to load map.\n");
            maplevel = old_level;
            (void) load_edit_map(pl,0);
          }
          return;
        }
      LOG(llevError,"No exit-objects there.\n");
      return;
    }
    if(button==2) {
      if(moved) return;
      if((pl->e_ob=get_map_ob(pl->emap,mx+pl->edx,my+pl->edy))!=NULL) {
        dump_object(pl->e_ob);
        LOG(llevError,"%s\n",errmsg);
	while (pl->e_ob->above) {	/* edit the top object */
	  pl->e_ob = pl->e_ob->above;
	  dump_object(pl->e_ob);
	  LOG(llevError,"%s\n",errmsg);
	}
        if(pl->e_ob->head!=NULL) {
          LOG(llevError,"More:\n");
          pl->e_ob=pl->e_ob->head;
          dump_object(pl->e_ob);
          LOG(llevError,"%s\n",errmsg);
        }
      }
      redraw_edit_item(pl);
      return;
    }

    if(button==3||(button==1&&pl->eselect!=0)) { /* eselect is never 0.. */
      /* button 1  does replace of all objects
       * button 3  adds one object above the others or removes one object
       *           if background selected if no object lefts add background
       *           button 3 also delete equal objects
       */
      Fontindex f = pl->eselect!=0 ? pl->eselect : G_BLANK;

      if(button==3&&pl->earchselect==NULL)
        f=G_BLANK;
      if(button==1 || pl->earchselect==NULL) {
        archetype *at;
        object *op;
        int flag=0; /* Always remove 0,0 even if at==NULL */
        for(at=pl->earchselect;at!=NULL||!flag;at=at?at->more:NULL,flag=1) {
          int x=mx+pl->edx+(at==NULL?0:at->clone.x),
              y=my+pl->edy+(at==NULL?0:at->clone.y);
          if(out_of_map(pl->emap,x,y))
            continue;

	  op=get_map_ob(pl->emap,x,y);
	  while (op) {
	    opa = op->above;
	    if (button == 1 || !opa) {
	      remove_ob_from_editor(pl,op);
	    } else {
	      f = op->type==EARTHWALL ? G_EARTHW3 : op->face;
	    }
	    op = opa;
	  }
	  set_omap(pl->emap,mx+pl->edx,my+pl->edy,f);
	  if (f == G_BLANK)
	    set_map(pl->emap,x,y,G_BLANK);
#if 0
          set_omap(pl->emap,x,y,G_BLANK);
          set_map(pl->emap,x,y,G_BLANK);
	  while((op=get_map_ob(pl->emap,x,y))!=NULL) {
            opa = op->above;
	    if (button == 1 || op->above
            remove_ob_from_editor(pl,op);
            op = opa;
          }
#endif
        }
      }
      /* Right button now removes equal objects */
      if((button==3)&&(op=get_map_ob(pl->emap,mx+pl->edx,my+pl->edy))!=NULL) {
        if(moved&&last_x==mx+pl->edx&&last_y==my+pl->edy)
          return;
        last_x=mx+pl->edx,last_y=my+pl->edy;
        while(op&&op->above!=NULL)
          op=op->above;
        if(op->head!=NULL)
          op=op->head;
        if(op->arch==pl->earchselect) {
          archetype *at;
          remove_ob(op);
            update_edit_square(pl,op->x,op->y);
          for(at=op->arch;at!=NULL;at=at->next)
            update_edit_square(pl,op->x+at->clone.x,op->y+at->clone.y);
          free_object(op);
          return;
        }
      }
      set_omap(pl->emap,mx+pl->edx,my+pl->edy,f);

      /* If we're placing an object on the map, then link and place it: */

      if(pl->earchselect!=NULL) {
        object *tmp;
        archetype *at=pl->earchselect;
        object *last_more=NULL,*head=NULL;
        if(arch_out_of_map(pl->earchselect,pl->emap,mx+pl->edx,my+pl->edy))
          return;
        while(at!=NULL) {
          op=arch_to_object(at);
          f=op->face;
          op->x+=mx+pl->edx,op->y+=my+pl->edy;
          update_walls(pl,mx+pl->edx+at->clone.x,my+pl->edy,4+mx*24,28+24*my);
          if(head==NULL)
            head=op;
          else
            op->head=head,last_more->more=op;
          at=at->more;
          last_more=op;
        }
        if(head!=NULL)
          insert_ob_in_map(head,pl->emap);
        if(f==G_EARTHW1)
          set_map(pl->emap,mx+pl->edx,my+pl->edy,G_EARTHW2);
        for(tmp=head;tmp!=NULL;tmp=tmp->more)
          update_edit_square(pl,tmp->x,tmp->y);
        return;
      }
      else {
        set_map(pl->emap,mx+pl->edx,my+pl->edy,f);
        update_walls(pl,mx+pl->edx,my+pl->edy,4+mx*24,28+24*my);
        update_edit_square(pl,mx+pl->edx,my+pl->edy);
      }
      return;
    }
  }
  if(!buffered) {
    int b=2+((24*pl->emx-2)*pl->emx)/pl->emap->mapx;
    if(x>4&&x<pl->emx*24&&y>10+pl->emy*24&&y<25+pl->emy*24) {
      if(x>4+pl->emx*24-b)
        x=4+pl->emx*24-b;
      pl->edx=(x-2)*pl->emap->mapx/(24*pl->emx-2);
      refresh_edit(pl);
      return;
    }
    b=2+((24*pl->emy-2)*pl->emy)/pl->emap->mapy;
    if(y>4&&y<pl->emy*24&&x>10+pl->emx*24&&x<25+pl->emx*24) {
      if(y>4+pl->emy*24-b)
        y=4+pl->emy*24-b;
      pl->edy=(y-2)*pl->emap->mapy/(24*pl->emy-2);
      refresh_edit(pl);
      return;
    }
  }
  for(i=0;XCharToFontindex(bg_icons[i])!=0;i++)
    if(bg_posx[i]-2<=x&&bg_posx[i]+26>=x&&bg_posy[i]-26<=y&&bg_posy[i]+2>=y) {
      pl->eselect=XCharToFontindex(bg_icons[i]);
      pl->earchselect=NULL;
      if(i<WALLS) {
        pl->ewall=i;
        update_wall_sel(pl);
        refresh_bg_icons(pl);
      }
      if((i>=WALLS&&i<WALLS+15)&&
         (pl->ewall>=REAL_WALLS&&pl->ewall<REAL_WALLS+ARCH_WALLS)) {
        pl->earchselect=face_to_archetype(XCharToFontindex(bg_icons[i]));
        pl->eselect=G_BLANK;
      } else if(i>=REAL_WALLS&&i<REAL_WALLS+ARCH_WALLS) {
        pl->earchselect=face_to_archetype(XCharToFontindex(bg_icons[i]));
        pl->eselect=G_BLANK;
      }
      fix_map=(i<REAL_WALLS);
      if (pl->iscolor){
        biff = XCharToFontindex(bg_icons[i]);
        XSetForeground(pl->gdisp,pl->gc_game,
          pl->discolor[itemcolor[biff][0]].pixel);
        XSetBackground(pl->gdisp,pl->gc_game,
          pl->discolor[itemcolor[biff][1]].pixel);
      }
#ifdef BEFORE_PIXMAPS
      XDRAWIMAGESTRING(pl->gdisp,pl->win_game,pl->gc_game,82,pl->emy*24+68,
                       bg_icons+i,1);
#else
      draw_face(pl,pl->win_game,pl->gc_game,82,pl->emy*24+68,XCharToFontindex(bg_icons[i]));
#endif
      return;
    }
  { /* Check the arch-types & its scrollbar */
    int my=(y-48-bg_posy[BG_SIZE-2])/24;
    if(x>pl->emx*24+46&&x<pl->emx*24+226&&my>=0&&my<bar_items) {
      int i;
      archetype *at;
#ifdef BEFORE_PIXMAPS
      XChar buf;
#endif

      fix_map=0;
      for(at=first_archetype,i=0;
          at!=NULL&&(!EDIT_OB((&at->clone))||my>i-pl->archd);
          at=at->next)
        if(EDIT_OB((&at->clone)))
          i++;
      pl->eselect=G_BLANK;
      pl->earchselect=at;
      if (pl->iscolor){
        biff = at->clone.face;
        XSetForeground(pl->gdisp,pl->gc_game,
          pl->discolor[itemcolor[biff][0]].pixel);
        XSetBackground(pl->gdisp,pl->gc_game,
          pl->discolor[itemcolor[biff][1]].pixel);
      }
#ifdef BEFORE_PIXMAPS
      buf = FontindexToXChar(at->clone.type==EARTHWALL ? G_EARTHW3 : 
			   at->clone.face);
      XDRAWIMAGESTRING(pl->gdisp,pl->win_game,pl->gc_game,82,pl->emy*24+68,
                       &buf,1);
#else
      draw_face(pl,pl->win_game,pl->gc_game,82,pl->emy*24+68,
                at->clone.type == EARTHWALL ? G_EARTHW3 : at->clone.face);
#endif
      return;
    }
    if(x>pl->emx*24+230&&x<pl->emx*24+250&&y>(y-48)&&my<bar_items) {
      archetype *at;
      int nrofat,delta=1+my;
      if(moved) return;
      for(at=first_archetype,nrofat=0;at!=NULL;at=at->next)
        if(EDIT_OB((&at->clone)))
          nrofat++;
      if(button==1)
        pl->archd-=delta;
      else if(button==3)
        pl->archd+=delta;
      if(pl->archd<0)
        pl->archd=0;
      else if(pl->archd>=nrofat-bar_items)
        pl->archd=nrofat-bar_items-1;
      (void) draw_arch_scroll(pl,bg_posy[BG_SIZE-2]+46);
      return;
    }
  }
  { /* Check the buttons */
    int i;
    for(i=0;i<NROFBUTTONS;i++)
      if(x>buttons_x[i]&&x<buttons_x[i]+buttons_w[i]&&y>buttons_y[i]&&y<buttons_y[i]+28) {
        if(moved) return;
        switch(i) {
        case BUTTON_NEXT:
          write_state=0;
          while(++maplevel<1000&&load_edit_map(pl,1));
          break;
        case BUTTON_PREV:
          write_state=0;
          if(maplevel==1)
            break;
          while(--maplevel>0&&load_edit_map(pl,1));
          break;
        case BUTTON_LOAD:
          write_state=0;
          (void) load_edit_map(pl,0);
          break;
        case BUTTON_SAVE:
          if(!strcmp(pl->emap->name,"Unnamed")) {
            LOG(llevError,"Give the map a name before trying to save it.\n");
            break;
          }
          write_state=0;
          save_edit_map(pl);
          (void) load_edit_map(pl,0); /* Since the new save-function removes all objects */
          break;
        case BUTTON_QUIT:
          exit(0);
        case BUTTON_LEVEL:
          if(write_state)
            break;
          write_pos=0,write_state=i,write_d=6;
          strcpy(buttons[i],"Level:   ");
          break;
        case BUTTON_NAME:
          if(write_state) break;
          write_pos=0,write_state=i,write_d=5;
          strcpy(buttons[i],"Map:                 ");
          break;
        case BUTTON_PATH:
          if(write_state) break;
          write_pos=0,write_state=i,write_d=6;
          strcpy(buttons[i],"Path:                 ");
          break;
        case BUTTON_MAPX:
          if(write_state) break;
          write_pos=0,write_state=i,write_d=6;
          strcpy(buttons[i],"Width:   ");
          break;
        case BUTTON_MAPY:
          if(write_state) break;
          write_pos=0,write_state=i,write_d=7;
          strcpy(buttons[i],"Height:   ");
          break;
        case BUTTON_STARTX:
          if(write_state) break;
          button_flag=1;
          break;
        case BUTTON_STARTY:
          if(write_state) break;
          button_flag=1;
          break;
        case BUTTON_ENTER:
          if(write_state) break;
          button_flag=2;
          break;
        case BUTTON_MONSTER:
          if(write_state) break;
          if(!generators&&!hidden&&!others)
            break;
          monsters = !monsters;
          sprintf(buttons[i],"Monsters: %1d",monsters);
          last_bard = 0;
          pl->archd = 0;
          pl->earchselect=NULL;
          draw_arch_scroll(pl,bg_posy[BG_SIZE-2]+46);
          break;
        case BUTTON_GENERATOR:
          if(write_state) break;
          if(!monsters&&!hidden&&!others)
            break;
          generators = !generators;
          sprintf(buttons[i],"Generators: %1d",generators);
          last_bard = 0;
          pl->archd = 0;
          pl->earchselect=NULL;
          draw_arch_scroll(pl,bg_posy[BG_SIZE-2]+46);
          break;
        case BUTTON_HIDDEN:
          if(write_state) break;
          if(!monsters&&!monsters&&!others)
            break;
          hidden = !hidden;
          sprintf(buttons[i],"Hidden: %1d",hidden);
          last_bard = 0;
          pl->archd = 0;
          pl->earchselect=NULL;
          draw_arch_scroll(pl,bg_posy[BG_SIZE-2]+46);
          break;
        case BUTTON_OTHERS:
          if(write_state) break;
          if(!monsters&&!monsters&&!hidden)
            break;
          others = !others;
          sprintf(buttons[i],"Others: %1d",others);
          last_bard = 0;
          pl->archd = 0;
          pl->earchselect=NULL;
          draw_arch_scroll(pl,bg_posy[BG_SIZE-2]+46);
          break;
        default:
          return;
        }
        XDrawImageString(pl->gdisp,pl->win_game,pl->etext,
                         buttons_x[i]+2,buttons_y[i]+20,
                         buttons[i],strlen(buttons[i]));
        return;
      }
  }
  /* Check the edit_ob window */
  if(!moved&&x>pl->eobx&&x<pl->eobx+200&&y>pl->eoby&&y<pl->eoby+pl->eobh) {
    click_edit(pl,(y-pl->eoby-5)/13);
    return;
  }
}

void draw_edit_line(player *pl, int line, char *text) {
  char buf[MAX_BUF];
  if(text==NULL)
    strcpy(buf,"(null)");
  else
    strncpy(buf,text,MAX_BUF);
  strcat(buf,"                         ");
  XDrawImageString(pl->gdisp,pl->win_game,pl->etext,
                   pl->eobx,pl->eoby+13*line+13,buf,22);
}

#if 0 /* An editor is spawned instead nowadays */

/********************************************************************
put_message: written by tvangod@ecst.csuchico.edu

Description: This routine takes a line of text and puts it on line
            number specified in line. The message will be tagged with
            the object *tmp.
********************************************************************/

void put_message(object *tmp, int line, char *text){
  int i;
  char *cp, *tmp2 = (char *) calloc(sizeof(char),VERY_BIG_BUF);
  if(message[line-7]!=NULL)
    free(message[line-7]);
  message[line-7]=strdup_local(strcat(text,"\n"));
  if(tmp->msg!=NULL) {
    free_string(tmp->msg);
    tmp->msg=NULL;
  }
  for (i=0; i<line-7;i++) {
    if(message[i]==NULL)
      strcat(tmp2,"\n");
    else
      strcat(tmp2,message[i]);
  }
  for (i=line-7; i<20;i++)
    if (message[i]!=NULL)
      strcat(tmp2,message[i]);

  for(cp=tmp2+strlen(tmp2)-1;cp>=tmp2&&*tmp2=='\n';cp++)
    cp='\0'; /* Clear trailing lineshifts */
  tmp->msg=add_string(tmp2);
  free(tmp2);
}

#endif

void receive_edit_line(player *pl, object *tmp, int line, char *text) {
  int i;
  if(tmp==NULL) {
    LOG(llevError,"Received edit line without having a chosen object.\n");
    return;
  }
  if(IS_FREED(tmp)) /* OOps... */
    return;
  if(line==1) {
    if(tmp->name!=NULL)
      free_string(tmp->name);
    tmp->name=add_string(text);
    redraw_edit_item(pl);
    return;
  }

#if 0 /* This is superseeded by spawning an editor */
/* If a line has been clicked in the edit_line window and its between line 6
   and 28, then a line of text is being entered.    */ 
  if((line>6) && (line<28)){
    clrload_mesg(tmp);
    put_message(tmp,line,text);
    return;
  }
#endif

  sscanf(text,"%d",&i);
  switch(tmp->type) {
  case SHOP_FLOOR:
    if(line==2) {
      SET_GENERATE_TYPE(tmp,i);
      redraw_edit_item(pl);
    }
    return;
  case PEDESTAL:
    if (line==2)
      tmp->stats.sp=i;
    else if (line==3) {
      if(tmp->slaying!=NULL)
        free_string(tmp->slaying);
      tmp->slaying = add_string(text);
    }
    redraw_edit_item(pl);
    return;
  case BUTTON:
  case GATE:
  case HANDLE:
  case HOLE:
    if(line==2)
      tmp->stats.sp=i;
    redraw_edit_item(pl);
    if(tmp->type!=HOLE)
      return;
  case EXIT:
  case STAIR:
  case TELEPORTER:
  case TRAPDOOR:
    switch(line) {
    case 2:
      if(tmp->type!=HOLE)
        EXIT_LEVEL(tmp)=i;
      break;
    case 3:
      EXIT_X(tmp)=i;
      break;
    case 4:
      EXIT_Y(tmp)=i;
      break;
    case 5:
      if(tmp->msg!=NULL)
        free_string(tmp->msg);
      tmp->msg=add_string(text);
      break;
    }
    redraw_edit_item(pl);
    return;
  case ALTAR:
    switch(line) {
      case 2:
        tmp->stats.sp=i;
        break;
      case 3:
        if(tmp->slaying != NULL)
          free_string(tmp->slaying);
        tmp->slaying = add_string(text);
        break;
      case 4:
        tmp->stats.food = i;
        break;
     }
     redraw_edit_item(pl);
     return;
  default:
    LOG(llevError,"Received unimplemented change in object.\n");
  }
}

void click_edit(player *pl, int line) {
  if(write_state)
    return;
  if(pl->e_ob==NULL)
    return;
  switch(line) {
  case 1:
    write_pos=0,write_state= -line,write_d=0;
    draw_edit_line(pl,1," ");
    break;
  case 2:
    switch(pl->e_ob->type) {
    case SHOP_FLOOR:
      write_pos=0,write_state= -line,write_d=5;
      draw_edit_line(pl,2,"Type:   ");
      break;
    case GATE:
    case HOLE:
    case BUTTON:
    case PEDESTAL:
    case HANDLE:
    case ALTAR:
      write_pos=0,write_state= -line,write_d=10;
      draw_edit_line(pl,2,"Connected:   ");
      break;
    case TRAPDOOR:
      write_pos=0,write_state= -line,write_d=7;
      draw_edit_line(pl,2,"Weight:   ");
      break;
    case EXIT:
    case STAIR:
    case TELEPORTER:
      write_pos=0,write_state= -line,write_d=9;
      draw_edit_line(pl,2,"To level:   ");
      break;
    }
    break;
  case 3:
    switch(pl->e_ob->type) {
    case EXIT:
    case STAIR:
    case TELEPORTER:
    case HOLE:
    case TRAPDOOR:
      write_pos=0,write_state= -line,write_d=2;
      draw_edit_line(pl,3,"X:   ");
      break;
    case PEDESTAL:
      write_pos=0,write_state= -line,write_d=5;
      draw_edit_line(pl,3,"Race:             ");
      break;
    case ALTAR:
      write_pos=0,write_state= -line,write_d=11;
      draw_edit_line(pl,3,"Sacrifice:             ");
      break;
    }
    break;
  case 4:
    switch(pl->e_ob->type) {
    case EXIT:
    case STAIR:
    case TELEPORTER:
    case HOLE:
    case TRAPDOOR:
      write_pos=0,write_state= -line,write_d=2;
      draw_edit_line(pl,4,"Y:   ");
      break;
    case ALTAR:
      write_pos=0,write_state= -line,write_d=6;
      draw_edit_line(pl,4,"Count:    ");
      break;
    }
    break;
  case 5:
    switch(pl->e_ob->type) {
    case EXIT:
    case STAIR:
    case TELEPORTER:
    case HOLE:
    case TRAPDOOR:
      write_pos=0,write_state= -line,write_d=5;
      draw_edit_line(pl,4,"Path:   ");
      break;
    }
    break;
  default:
    if (line>6){
#if 0
      write_pos=0,write_state= -line,write_d=0;
      draw_edit_line(pl,line," ");
#else
      char *msg=pl->e_ob->msg;
      msg=edit_string(msg);
      if(pl->e_ob->msg!=NULL)
        free(pl->e_ob->msg);
      pl->e_ob->msg=msg;
#endif
    }
  }
}

/********************************************************************
clrload: written by tvangod@ecst.csuchico.edu

Description: This routine clears out the message array, local to 
             edit.c and then puts in the message of tmp, if any 
             exists.
********************************************************************/

void clrload_mesg(object *tmp){
  int i,j,k;
  char buf[MAX_BUF];

  for(i=0;i<20;i++)
    if(message[i]!=NULL){
      free(message[i]);
      message[i]=NULL;
    }
  if(tmp->msg!=NULL){
    i=0;
    buf[k=0]='\0';
    for(j=0; j<=strlen(tmp->msg); j++)
      if(tmp->msg[j]!='\n')
        buf[k++]=tmp->msg[j];
      else {
        buf[k]='\0';
        message[i++]=(char *)strdup_local(strcat(buf,"\n"));
        buf[k=0]='\0';
      }
  }
}

void redraw_edit_item(player *pl) {
  int i;
  char buf[MAX_BUF];
  XClearArea(pl->gdisp,pl->win_game,pl->eobx,pl->eoby+4,198,pl->eobh-8,0);
  if(pl->e_ob==NULL) {
    draw_edit_line(pl,1,"No object selected.");
    return;
  }
  draw_edit_line(pl,6,"Message:");
  draw_edit_line(pl,27,"Message End:");
  clrload_mesg(pl->e_ob);
  for(i=0;i<20;i++)
    if (message[i]!=NULL){
      strcpy(buf,message[i]);
      buf[strlen(buf)-1]='\0';
      draw_edit_line(pl,(7+i),buf);
    }
  draw_edit_line(pl,1,pl->e_ob->name);

  switch(pl->e_ob->type) {
  case STAIR:
  case TELEPORTER:
  case EXIT:
  case TRAPDOOR:
    if(pl->e_ob->type==TRAPDOOR)
      sprintf(buf,"Weight:%3d",pl->e_ob->weight);
    else
      sprintf(buf,"To level:%3d",EXIT_LEVEL(pl->e_ob));
    draw_edit_line(pl,2,buf);
    sprintf(buf,"X:%3d",EXIT_X(pl->e_ob));
    draw_edit_line(pl,3,buf);
    sprintf(buf,"Y:%3d",EXIT_Y(pl->e_ob));
    draw_edit_line(pl,4,buf);
    sprintf(buf,"Path:%-16s",pl->e_ob->msg);
    draw_edit_line(pl,5,buf);
    return;
  case HOLE:
    sprintf(buf,"Connected:%3d",pl->e_ob->stats.sp);
    draw_edit_line(pl,2,buf);
    sprintf(buf,"X:%3d",EXIT_X(pl->e_ob));
    draw_edit_line(pl,3,buf);
    sprintf(buf,"Y:%3d",EXIT_Y(pl->e_ob));
    draw_edit_line(pl,4,buf);
    return;
  case GATE:
  case BUTTON:
  case HANDLE:
    sprintf(buf,"Connected:%3d",pl->e_ob->stats.sp);
    draw_edit_line(pl,2,buf);
    return;
  case PEDESTAL:
    sprintf(buf,"Connected:%3d",pl->e_ob->stats.sp);
    draw_edit_line(pl,2,buf);
    sprintf(buf,"Race:%s", pl->e_ob->slaying);
    draw_edit_line(pl,3,buf);
    break;
  case ALTAR:
    sprintf(buf,"Connected:%3d",pl->e_ob->stats.sp);
    draw_edit_line(pl,2,buf);
    sprintf(buf,"Sacrifice:%s", pl->e_ob->slaying);
    draw_edit_line(pl,3,buf);
    sprintf(buf,"Count:%4d", pl->e_ob->stats.food);
    draw_edit_line(pl,4,buf);
    break;
  case SHOP_FLOOR:
    sprintf(buf,"Type:%3d",GENERATE_TYPE(pl->e_ob));
    draw_edit_line(pl,2,buf);
    return;
  }
}

int refresh_bg_icons(player *pl) {
  int x,y,i;
  Fontindex biff;
  for(y=48,i=0;y<pl->ehint.height&&XCharToFontindex(bg_icons[i])!=0;y+=48)
    for(x=pl->emx*24+48;
        x<pl->ehint.width-26&&XCharToFontindex(bg_icons[i])!=0;
        x+=48) {
      bg_posx[i]=x,bg_posy[i]=y;
      XDrawRectangle(pl->gdisp,pl->win_game,pl->gc_game,
                     x-2,y-26,28,28);
      if (pl->iscolor){
        biff = XCharToFontindex(bg_icons[i]);
        XSetForeground(pl->gdisp,pl->gc_game,
          pl->discolor[itemcolor[biff][0]].pixel);
        XSetBackground(pl->gdisp,pl->gc_game,
          pl->discolor[itemcolor[biff][1]].pixel);
      }
#ifdef BEFORE_PIXMAPS
      XDRAWIMAGESTRING(pl->gdisp,pl->win_game,pl->gc_game,
                       x,y,bg_icons+i++,1);
#else
      draw_face(pl,pl->win_game,pl->gc_game,x,y,XCharToFontindex(bg_icons[i]));
      i++;
#endif
    }
  return y;
}

void refresh_edit(player *pl) {
  int y,bottom,w,na;
  archetype *at;
  for(na=0,at=first_archetype;at!=NULL;at=at->next,na++);
  XClearWindow(pl->gdisp,pl->win_game);
  XSetForeground(pl->gdisp,pl->gc_game,pl->gforeground);
  XSetBackground(pl->gdisp,pl->gc_game,pl->gbackground);
  XDrawRectangle(pl->gdisp,pl->win_game,pl->gc_game,2,2,
                 pl->emx*24+4,pl->emy*24+4);
  XDrawRectangle(pl->gdisp,pl->win_game,pl->gc_game,pl->emx*24+8,2,
                 20,pl->emy*24+4);
  XDrawRectangle(pl->gdisp,pl->win_game,pl->gc_game,2,pl->emy*24+8,
                 pl->emx*24+4,20);
  pl->old_edy= -1,pl->old_edx= -1;
  draw_edit_map(pl);
  w=(pl->ehint.width-pl->emx*24+30)/48;
  if(w==0) {
    LOG(llevError,"Too small window!\n");
    return;
  }
  y=refresh_bg_icons(pl);
  bottom=draw_arch_scroll(pl,y-2);
  XDrawRectangle(pl->gdisp,pl->win_game,pl->gc_game,
                 pl->emx*24+46,y-4,180,bottom-y+4);
  XDrawRectangle(pl->gdisp,pl->win_game,pl->gc_game,
                 pl->emx*24+230,y-4,20,bottom-y+4);

  pl->eobx=pl->emx*24+254,pl->eoby=y-4,pl->eobh=bottom-y;
  XDrawRectangle(pl->gdisp,pl->win_game,pl->gc_game,
                 pl->eobx-2,pl->eoby,200,pl->eobh+4);
  XDrawImageString(pl->gdisp,pl->win_game,pl->etext,8,pl->emy*24+60,
                   "Selected:",9);
  XDrawRectangle(pl->gdisp,pl->win_game,pl->gc_game,80,pl->emy*24+40,28,28);
#if 0 /* Name of selected... */
  XDrawImageString(pl->gdisp,pl->win_game,pl->etext,100,pl->emy*24+60,
                   "Chosen",6);
#endif
  {
    int i,x=160,y;
    for(i=0,y=pl->emy*24+40;i<NROFBUTTONS&&y+28<pl->ehint.height;y+=32,x=2)
      for(;i<NROFBUTTONS&&x+(buttons_w[i]=strlen(buttons[i])*8)<pl->emx*24+40;
          x+=strlen(buttons[i++])*8+16) {
        buttons_x[i]=x,buttons_y[i]=y;
        XDrawImageString(pl->gdisp,pl->win_game,pl->etext,
                         buttons_x[i]+2,buttons_y[i]+20,
                         buttons[i],strlen(buttons[i]));
        XDrawRectangle(pl->gdisp,pl->win_game,pl->gc_game,
                       buttons_x[i],buttons_y[i],buttons_w[i]+2,28);
      }
    if(i<NROFBUTTONS)
      LOG(llevError,"Window is too small!\n");
  }
  redraw_edit_item(pl);
}

void update_vars(player *pl) {
  int i,j,x,buttonlines;
  sprintf(buttons[BUTTON_LEVEL],"Level:%3d",maplevel);
  sprintf(buttons[BUTTON_NAME],"Map: %-16s",pl->emap->name);
  sprintf(buttons[BUTTON_PATH],"Path: %-16s",pl->emap->path);
  sprintf(buttons[BUTTON_MAPX],"Width:%3d",pl->emap->mapx);
  sprintf(buttons[BUTTON_MAPY],"Height:%3d",pl->emap->mapy);
  sprintf(buttons[BUTTON_STARTX],"Start X:%3d",pl->emap->startx);
  sprintf(buttons[BUTTON_STARTY],"Start Y:%3d",pl->emap->starty);
  pl->emx=edit_width;
  if(pl->emx>pl->emap->mapx) pl->emx=pl->emap->mapx;
  for(x=160,i=0,buttonlines=1;i<NROFBUTTONS&&buttonlines<NROFBUTTONS;) {
    if((x+=strlen(buttons[i])*8+16)>pl->emx*24+40)
      x=2,buttonlines++;
    else
      i++;
  }
  edit_height=(pl->ehint.height-buttonlines*32-40)/24-1;
  pl->edx=0,pl->edy=0;
  pl->emy=edit_height;
  if(pl->emy>pl->emap->mapy) pl->emy=pl->emap->mapy;
  for(i=0;i<pl->emap->mapx;i++)
    for(j=0;j<pl->emap->mapy;j++)
      if(get_map(pl->emap,i,j)==G_EARTHW1)
        set_map(pl->emap,i,j,G_EARTHW3);
}

void load_edit_empty_map(player *pl, int x, int y) {
  pl->emap=get_empty_map(x,y);
  strcpy(pl->emap->name,"Unnamed");
  update_vars(pl);
  if(pl->gdisp!=NULL)
    refresh_edit(pl);
}

void resize_map(player *pl, int dx, int dy) {
  int mx=pl->emap->mapx+dx,my=pl->emap->mapy+dy;
  mapstruct *tmp=get_empty_map(mx,my);
  copy_map(pl->emap,tmp);
  if(pl->emap!=NULL) {
    pl->emap->level= -2;
    move_all_objects(pl->emap,tmp);
    free_map(pl->emap,0); /* The 0 means we don't free any objects */
  }
  pl->emap=tmp;
  update_vars(pl);
  if(pl->gdisp!=NULL)
    refresh_edit(pl);
}

/*
 * load_edit_map(pl,flag): If flag is set, and it fails to load the map,
 * it returns 1 instead of loading an empty map.
 */

int load_edit_map(player *pl, int flag) {
  if(pl->e_ob!=NULL)
    pl->e_ob=NULL;
  if(pl->emap!=NULL) {
    pl->emap->level= -2; /* I don't want more to do with it for now */
    free_map(pl->emap,1);
  }
  if(pl->mappath!=NULL)
    pl->emap=ready_map_name(pl->mappath,1);
  else
    pl->emap=ready_map(maplevel,1);
  if(pl->emap==NULL) {
    if(flag)
      return 1;
    load_edit_empty_map(pl,16,16);
    return 1;
  }
  (void) calculate_difficulty(pl->emap);
  update_vars(pl);
  if(pl->gdisp!=NULL)
    refresh_edit(pl);
  return 0;
}

void save_edit_map(player *pl) {
  mapstruct *m;

  m=pl->emap;
  m->level=maplevel;
  if(m->path==NULL)
    update_map_name(m->level,m->name);
  save_omap(m,1);
  save_map(m,1);
}

void handle_key(player *pl,char k) {
  int i;
  if(k==13) {
    write_buf[write_pos]='\0';
    if(write_state<1) {
      object *tmp;
      for(tmp=pl->e_ob;tmp!=NULL;tmp=tmp->more)
        receive_edit_line(pl,tmp,-write_state,write_buf);
      write_state=0;
      return;
    }
    switch(write_state) {
    case BUTTON_LEVEL:
      sscanf(write_buf,"%d",&maplevel);
      sprintf(buttons[write_state],"Level:%3d",maplevel);
      break;
    case BUTTON_NAME:
      {
        char *cp;
        for(cp=write_buf;*cp!='\0';cp++) {
          if(*cp==' ')
            *cp='_';
          else if(*cp>='A'&&*cp<='Z')
            (*cp)+=32;
        }
      }
      sprintf(buttons[write_state],"Map: %-16s",write_buf);
      strncpy(pl->emap->name,write_buf,BIG_NAME);
      break;
    case BUTTON_PATH:
      {
        char *cp;
        for(cp=write_buf;*cp!='\0';cp++) {
          if(*cp==' ')
            *cp='_';
          else if(*cp>='A'&&*cp<='Z')
            (*cp)+=32;
        }
      }
      sprintf(buttons[write_state],"Path: %-16s",write_buf);
      strncpy(pl->emap->name,write_buf,BIG_NAME);
      break;
    case BUTTON_MAPX:
      sscanf(write_buf,"%d",&i);
      sprintf(buttons[write_state],"Width:%3d",i);
      resize_map(pl,i-pl->emap->mapx,0);
      break;
    case BUTTON_MAPY:
      sscanf(write_buf,"%d",&i);
      sprintf(buttons[write_state],"Height:%3d",i);
      resize_map(pl,0,i-pl->emap->mapy);
      break;
    case BUTTON_STARTX:
    case BUTTON_STARTY:
      button_flag=1;
      break;
    }
    XDrawImageString(pl->gdisp,pl->win_game,pl->etext,
                     buttons_x[write_state]+2,buttons_y[write_state]+20,
                     buttons[write_state],strlen(buttons[write_state]));
    write_state=0;
    return;
  }
  if(k==8||k==127) {
    if(!write_pos)
      return;
    if(write_state>=0)
      XDrawImageString(pl->gdisp,pl->win_game,pl->etext,
                       buttons_x[write_state]+2+(write_pos-- + write_d-1)*8,
                       buttons_y[write_state]+20," ",1);
    else
      XDrawImageString(pl->gdisp,pl->win_game,pl->etext,
                       pl->eobx+(write_pos-- +write_d-1)*8,
                       pl->eoby+(-write_state)*13+13,&k,1);
    return;
  }
  if(write_state>=0&&write_pos+write_d>=strlen(buttons[write_state]))
    return;
  if(write_state<0&&write_pos>24)
    return;
  if((k<'a'||k>'z')&&(k<'A'||k>'Z')&&(k<'0'||k>'9')&&
     k!='.'&&k!='_'&&k!='-'&&k!=' ')
    return;
  write_buf[write_pos++]=k;
  if(write_state>=0)
    XDrawImageString(pl->gdisp,pl->win_game,pl->etext,
                     buttons_x[write_state]+2+(write_pos+write_d-1)*8,
                     buttons_y[write_state]+20,&k,1);
  else
    XDrawImageString(pl->gdisp,pl->win_game,pl->etext,
                     pl->eobx+(write_pos+write_d-1)*8,
                     pl->eoby+(-write_state)*13+13,&k,1);
}

void edit(char *arg) {
  player *e_pl=get_player_ob();
  int count;
  char **list;
  Font efont;
  XEvent eevent;
  Time last_event=CurrentTime;
  int last_button=0;
  int nx,ny;
  KeySym ekey;
  char text[10];
  XFontStruct *xfp;
  char *my_display=(char *) getenv("DISPLAY");
#ifdef HAVE_SAVE_UID
  uid_t olduid;
#endif
#ifndef LET_ANYONE_EDIT
  struct passwd *rpwd;
  FILE *allowfile;
  int allowed;
  char allowfname[256], allowline[256], *allowp;
#endif


/*
 * To control who is allowed to edit maps. If crossfire is run setuid,
 * we want to check against editing by random users.
 *  //magnuz@cd.chalmers.se
 */
#ifndef LET_ANYONE_EDIT   /* Do some checks on who is allowed to edit */
  rpwd = getpwuid(getuid()); /* get pwd entry of person invoking program */
  if(!rpwd) {
      fprintf(stderr, "Error in getpwuid(). Who are you?!\n");
      exit(0);
  }

  allowed = 0;
#ifdef ALLOWFILE
  strcpy(allowfname, LIBDIR);
  strcat(allowfname, "/");
  strcat(allowfname, ALLOWFILE);  /* No checks on name size, but ... :-) */

  if(allowfile = fopen(allowfname, "r")) { /* Read the permission file */
      while(fgets(allowline, 256, allowfile)) {
        if(allowp = index(allowline, '#'))            /* strip comments */
            *allowp = '\0';
        allowp = allowline;
        while(isspace((int) *allowp)) *allowp++; /* strip leading spaces */
        if(!*allowp) continue;
        if(allowp != allowline) strcpy(allowline, allowp);
        allowp = allowline + strlen(allowline) - 1;
        while(isspace((int) *allowp)) *allowp-- = '\0'; /* trailing spaces */
        if(!strlen(allowline)) continue;
        if(!strcmp(allowline, rpwd->pw_name)) {
            allowed = 1;
            break;
        }
      }
      fclose(allowfile);
  } else
      fprintf(stderr, "(couldn't open %s)\n", allowfname);
#else /* ALLOWFILE */
  if(getuid() == geteuid())  /* invoked by owner */
      allowed = 1;
#endif /* ALLOWFILE */

  if(!allowed) {    /* if the user wasn\'t anywhere in the list */
#ifdef ALLOWER
      fprintf(stderr, "Map editing is limited, but talk to ");
      fprintf(stderr, "%s if\nyou want to create maps.\n", ALLOWER);
#else
      fprintf(stderr, "Map editing is limited.\n");
#endif  /* ALLOWER */
      exit(0);
  }

#endif  /* !LET_ANYONE_EDIT */

  init_archetypes(); /* If not called before, reads all archetypes from file */

  e_pl=get_player_ob();
  e_pl->ob=get_object();
  SET_WIZ(e_pl->ob); /* To avoid Line Of Sight calculations (ugly) */

  e_pl->emap=NULL;
  e_pl->gdisp=NULL;
  e_pl->e_ob=NULL;
  if(my_display==NULL) {
    LOG(llevError,"DISPLAY isn't defined.\n");
    exit(-1);
  }

#ifdef HAVE_SAVE_UID
  olduid = geteuid(); /* I like to run it suid :) */
  setuid(getuid());		/* Have to this to open display, */
				/* if anyone is using xauth like me. */
#endif

  if((e_pl->gdisp=XOpenDisplay(my_display))==NULL) {
    LOG(llevError,"Couldn't open edit display at %s.\n",my_display);
    exit(-1);
  }

#ifdef HAVE_SAVE_UID
  setuid(olduid);		/* Back to owner of suid crossfire */
#else
  setuid(geteuid());		/* We want both ruid == euid */
#endif

  XSetErrorHandler(0);
  XSetIOErrorHandler(0);

  if (!(e_pl ->use_pixmaps = use_pixmaps)) {
    list=XListFonts(e_pl->gdisp,font_graphic,1,&count);
    XFreeFontNames(list);
    if(!count) {
      LOG(llevError,"Trying to fix fontpath.\n");
      set_font_path(e_pl->gdisp,FontDir);
      list=XListFonts(e_pl->gdisp,font_graphic,1,&count);
      XFreeFontNames(list);
      if(!count) {
        e_pl->use_pixmaps = 1;
        LOG(llevError,"Failed to set font-path.\n");
        exit(-1);
      }
    }
  }
  e_pl->escreen=DefaultScreen(e_pl->gdisp);
  allocate_ecolors(e_pl);
  if (e_pl->iscolor){
    e_pl->gforeground=e_pl->discolor[0].pixel;
    e_pl->gbackground=e_pl->discolor[8].pixel;
  }
  else{
    e_pl->gbackground=WhitePixel(e_pl->gdisp,e_pl->gscreen);
    e_pl->gforeground=BlackPixel(e_pl->gdisp,e_pl->gscreen);
  }
  e_pl->ehint.x=0,e_pl->ehint.y=0;
  e_pl->ehint.width=999,e_pl->ehint.height=600;
  e_pl->win_game=XCreateSimpleWindow(e_pl->gdisp,DefaultRootWindow(e_pl->gdisp),
    e_pl->ehint.x,e_pl->ehint.y,e_pl->ehint.width,e_pl->ehint.height,
    2,e_pl->gforeground,e_pl->gbackground);
  XSetStandardProperties(e_pl->gdisp,e_pl->win_game,"Crossfire Editor",
                         "Crossfire",None,gargv,gargc,&e_pl->ehint);
  XMapRaised(e_pl->gdisp,e_pl->win_game);
  e_pl->gc_game=XCreateGC(e_pl->gdisp,e_pl->win_game,0,0);
  if(!e_pl->use_pixmaps) {
    efont=XLoadFont(e_pl->gdisp,font_graphic);
  
    xfp=XQueryFont(e_pl->gdisp,efont);
    LOG(llevDebug, "font size %d %d\n", xfp->max_byte1, xfp->max_char_or_byte2);

    efont=XLoadFont(e_pl->gdisp,font_graphic);
    XSetFont(e_pl->gdisp,e_pl->gc_game,efont);
  } else {
    e_pl->gamehint.width = e_pl->ehint.width;
    e_pl->gamehint.height = e_pl->ehint.height;
    read_bmaps(e_pl);
  }
  e_pl->etext=XCreateGC(e_pl->gdisp,e_pl->win_game,0,0);
  efont=XLoadFont(e_pl->gdisp,"8x13");
  XSetFont(e_pl->gdisp,e_pl->etext,efont);
  XSetForeground(e_pl->gdisp,e_pl->etext,e_pl->gforeground);
  XSetBackground(e_pl->gdisp,e_pl->etext,e_pl->gbackground);
  XSelectInput(e_pl->gdisp,e_pl->win_game,
               ExposureMask|ButtonPressMask|ButtonReleaseMask|
               PointerMotionHintMask|ButtonMotionMask|KeyPressMask|
               StructureNotifyMask);

  if(editor==2) {
    e_pl->mappath=add_string(arg);
    (void) load_edit_map(e_pl,0);
  } else if(sscanf(arg,"%dx%d",&nx,&ny)==2)
    load_edit_empty_map(e_pl,nx,ny);
  else if(sscanf(arg,"%d",&maplevel))
    (void) load_edit_map(e_pl,0);
  else {
    LOG(llevError,
        "Illegal argument after -e.  Level or widthxheight expected.\n");
    exit(-1);
  }
  if(e_pl->emap==NULL) {
    LOG(llevError,"Couldn't open map %d.\n",maplevel);
    exit(-1);
  }
  dump_map(e_pl->emap);

  edit_width=(e_pl->ehint.width-456)/24;
  update_vars(e_pl);
  refresh_edit(e_pl);
  update_wall_sel(e_pl);

  for(;;) {
    int x,y;
    XNextEvent(e_pl->gdisp,&eevent);
    switch(eevent.type) {
    case ConfigureNotify:
      if(e_pl->ehint.width==eevent.xconfigure.width&&
         e_pl->ehint.height==eevent.xconfigure.height)
        break;
      e_pl->ehint.width=eevent.xconfigure.width,
      e_pl->ehint.height=eevent.xconfigure.height;
      edit_width=(e_pl->ehint.width-456)/24;
      if(edit_width<1)
        edit_width=1;
      XSetNormalHints(e_pl->gdisp,e_pl->win_game,&e_pl->ehint);
      XResizeWindow(e_pl->gdisp,e_pl->win_game,
                    eevent.xconfigure.width,eevent.xconfigure.height);
      update_vars(e_pl);
    case Expose:
      while(XEventsQueued(e_pl->gdisp,QueuedAfterReading)&&eevent.type==Expose)
        XNextEvent(e_pl->gdisp,&eevent);
      refresh_edit(e_pl);
      break;
    case KeyPress:
      (void) XLookupString(&eevent.xkey,text,10,&ekey,NULL);
      switch(ekey) {
      case XK_Up:
        if((e_pl->edy-=5)<0)
          e_pl->edy=0;
        draw_edit_map(e_pl);
        break;
      case XK_Down:
        if((e_pl->edy+=5)>e_pl->emap->mapy - e_pl->emy)
          e_pl->edy=e_pl->emap->mapy - e_pl->emy;
        draw_edit_map(e_pl);
        break;
      case XK_Left:
        if((e_pl->edx-=5)<0)
          e_pl->edx=0;
        draw_edit_map(e_pl);
        break;
      case XK_Right:
        if((e_pl->edx+=5)>e_pl->emap->mapx - e_pl->emx)
          e_pl->edx=e_pl->emap->mapx - e_pl->emx;
        draw_edit_map(e_pl);
        break;
      default:
        if(write_state)
          handle_key(e_pl,text[0]);
        else
          switch(text[0]) {
          case 'e':
            if(e_pl->e_ob!=NULL) {
              char *msg=e_pl->e_ob->msg;
              msg=edit_string(msg);
              if(e_pl->e_ob->msg!=NULL)
                free(e_pl->e_ob->msg);
              e_pl->e_ob->msg=msg;
            }
            break;
          }
      }
      break;
    case ButtonPress:
      x=eevent.xbutton.x,y=eevent.xbutton.y,last_button=eevent.xbutton.button;
      mouse_click(e_pl,x,y,last_button);
      last_event=eevent.xbutton.time;
      break;
    case ButtonRelease:                 /* Shouldn't have to handle this, but some */
      last_event=eevent.xbutton.time;   /* workstations are braindead... */
      break;
    case MotionNotify:
#ifndef __alpha
      if(e_pl->gdisp->motion_buffer!=0) { /* Does this display have buffer? */
        int nevents,i;
        XTimeCoord *mptr=XGetMotionEvents(e_pl->gdisp,e_pl->win_game,last_event,
                                          CurrentTime,&nevents);
        for(i=0;i<nevents;i++) {
          mouse_click(e_pl,mptr[i].x,mptr[i].y,last_button+6);
          last_event=mptr[i].time;
        }
        XFree((char *) mptr);
      }
      else
#endif
      { /* No (sigh), then only process where the mouse is right now */
        Window rw,cw;
        int xw,yw,xr,yr;
        unsigned int keys_buttons;
        (void) XQueryPointer(e_pl->gdisp,e_pl->win_game,
                             &rw,&cw,&xr,&yr,&xw,&yw,&keys_buttons);
        mouse_click(e_pl,xw,yw,last_button+3);
      }
    }
  }
}
