/*
 * static char *rcsid_main_c =
 *   "$Id: main.c,v 1.1.1.1 1993/03/07 08:31:00 frankj Exp $";
 */

/*
    CrossFire, A Multiplayer game for X-windows

    Copyright (C) 1992 Frank Tore Johansen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The author can be reached via e-mail to frankj@ifi.uio.no.
*/

#include <global.h>
#include "proto.h"

int
main(int argc, char **argv, char **env)
{
  char *ch;
  int i;

  editor = 1;
  init_library();	/* Initialize all function pointers */

  for(i = 1; i < argc; i ++)
  {
    int l = strlen(argv[i]);
    if (l > 1)
    {
      if (!strncmp(argv[i], "-debug", l))
      {
        debug = 1;
        continue;
      }
      if (!strncmp(argv[i], "-edit", l) || !strncmp(argv[i], "-Edit", l))
      {
        editor = (argv[i][1] == 'e' ? 1 : 2);
        if (++i == argc)
        {
          fprintf(stderr, "You must specify which map to edit after -edit.\n");
          return 1;
        }
        init_archetypes();
        edit(argv[i]);
        return 0;
      }
      if (!strncmp(argv[i], "-pix", l))
      {
        use_pixmaps = 1;
        continue;
      }
    }
    fprintf(stderr, "Unknown argument: %s\n",argv[i]);
    break;
  }
  ch = strrchr(argv[0],'/');
  fprintf(stderr,
"Usage: %s [-debug] [-pix] [-e <map_level> | <height>x<width>]\n",
          (ch == (char *) NULL ? argv[0] : ch + 1));
  return 1;
}
