/*
 * static char *rcsid_Cnv_h =
 *   "$Id: Cnv.h,v 1.1.1.1 1993/03/07 08:31:00 frankj Exp $";
 */

/*
	CrossEdit, A Editor for CrossFire, A Multiplayer game
	for X-windows	

	Copyright (C) 1993 Jarkko Sonninen & Petri Heinila

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	
	The authors can be reached via e-mail to Jarkko.Sonninen@lut.fi
	or Petri.Heinila@lut.fi .
*/

#ifndef _Cnv_h
#define _Cnv_h

/*** ANSI & Posix headers ***/
#include <stdio.h>
#include <limits.h>

#if !defined (NeXT)
#include <unistd.h>
#endif

/*** X-Headers ***/
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>

/*** Widget-Container-Headers ***/
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/List.h>

/*** Widget-Primitive-Headers ***/
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/Toggle.h>

/**********************************************************************/

typedef struct {
    Widget w;
    Widget t;			/* text Widget */
    String label;
    char value[BUFSIZ];
}   CnvTags;

#if defined __STDC__ || defined __cplusplus
Widget CnvGetShell (Widget child);
void CnvCenterWidget (Widget w);
int CnvNotify (Widget w, char *msg, char **list);
int CnvPrompt (Widget w, char *msg, char *sgg, char **ans, char **list);
Widget CnvAddButton (Widget parent, String label, XtCallbackProc proc);
void CnvTagsOpen (CnvTags tags[], Widget parent);
void CnvTagsClose (CnvTags tags[]);
void CnvTagsManage (CnvTags tags[], unsigned long select);
void CnvSyntax (Widget top, XtActionsRec * actions, Cardinal num_actions);
String CnvResourceFilePath (Widget w);

#else				/* classic */

Widget CnvGetShell ( /* Widget child */ );
void CnvCenterWidget ( /* Widget w */ );
int CnvNotify ( /* Widget w,char *msg,char **list */ );
int CnvPrompt (			/* Widget w,char *msg,char *sgg,char
      **ans,char **list */ );
#endif				/* defined __STDC__ || defined __cplusplus */

/* predefined buttons */

extern String CnvOk[];
extern String CnvOkCancel[];
extern String CnvOkApplyCancel[];
extern String CnvOkCancelNo[];
#endif				/*** _Cnv_h ***/
