/*
 * static char *rcsid_debug_h =
 *   "$Id: debug.h,v 1.1.1.1 1993/03/07 08:31:02 frankj Exp $";
 */

/*
	CrossEdit, A Editor for CrossFire, A Multiplayer game
	for X-windows	

	Copyright (C) 1993 Jarkko Sonninen & Petri Heinila

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	
	The authors can be reached via e-mail to Jarkko.Sonninen@lut.fi
	or Petri.Heinila@lut.fi .
*/

#ifndef _debug_h
#define _debug_h

#include <stdio.h>

#ifdef DEBUG
#define debug0(fmt) \
	{(void)fprintf(stderr,fmt);(void)fflush(stderr);}

#define debug1(fmt,p1)\
	{(void)fprintf(stderr,fmt,p1);(void)fflush(stderr);}

#define debug2(fmt,p1,p2)\
	{(void)fprintf(stderr,fmt,p1,p2);(void)fflush(stderr);}

#define debug3(fmt,p1,p2,p3)\
	{(void)fprintf(stderr,fmt,p1,p2,p3);(void)fflush(stderr);}

#define debug4(fmt,p1,p2,p3,p4)\
	{(void)fprintf(stderr,fmt,p1,p2,p3,p4);(void)fflush(stderr);}

#define debug5(fmt,p1,p2,p3,p4,p5)\
	{(void)fprintf(stderr,fmt,p1,p2,p3,p4,p5);(void)fflush(stderr);}

#else

#define debug0(fmt)
#define debug1(fmt,p1)
#define debug2(fmt,p1,p2)
#define debug3(fmt,p1,p2,p3)
#define debug4(fmt,p1,p2,p3,p4)
#define debug5(fmt,p1,p2,p3,p4,p5)
#endif				/* DEBUG */

#define die(msg)\
	{(void)fprintf(stderr,"Fatal: ");perror(msg);\
	(void)fflush(stderr);(void)exit(1);}
#endif				/* _debug_h */
