/*
 * static char *rcsid_dirty_c =
 *   "$Id: dirty.c,v 1.1.1.1 1993/03/07 08:31:02 frankj Exp $";
 */

/*
	CrossEdit, A Editor for CrossFire, A Multiplayer game
	for X-windows	

	Copyright (C) 1993 Jarkko Sonninen & Petri Heinila

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	
	The authors can be reached via e-mail to Jarkko.Sonninen@lut.fi
	or Petri.Heinila@lut.fi .
*/

/* #include <color.h> */
#include <editor.h>
#include <debug.h>

#if defined(MACH) || defined(vax) || defined(ibm032) || defined(NeXT)
#ifndef S_ISREG
#define S_ISREG(x) (((x) & S_IFMT) == S_IFREG)
#endif
#endif

Colormap colormap;
XColor exactcolor, discolor[16];
object *tmp;

#define get_foreground(op) (discolor[itemcolor[(op)->face][0]].pixel)
#define get_background(op) (discolor[itemcolor[(op)->face][1]].pixel)
 /* return (discolor[op->arch->bg_color].pixel); */
 /* return (discolor[op->arch->fg_color].pixel); */

int e_draw_object (Window w, int x, int y, object * tmp)
{
    XChar xbuf;
    if (!tmp || !tmp->face)
	tmp = &empty_archetype->clone;
    switch (tmp->face) {
    case 167:
	if (tmp->type == 91)
	    xbuf = FontindexToXChar (605);
	else if (tmp->type == 45)
	    xbuf = FontindexToXChar (168);
	else if (tmp->type == 62)
	    xbuf = FontindexToXChar (167);
	else
	    xbuf = FontindexToXChar (169);
	break;

    default:
	xbuf = FontindexToXChar (tmp->face);
    }
    XSetForeground (XtDisplay (app.w), app.gc, get_foreground (tmp));
    XSetBackground (XtDisplay (app.w), app.gc, get_background (tmp));
    XDRAWIMAGESTRING (XtDisplay (app.w), w, app.gc, x, y, &xbuf, 1);
    return (0);
}

int draw_object (Window w, int x, int y, object * tmp)
{
    XChar xbuf;
    if (!tmp || !tmp->face)
	tmp = &empty_archetype->clone;
    xbuf = FontindexToXChar (tmp->face);
    XSetForeground (XtDisplay (app.w), app.gc, get_foreground (tmp));
    XSetBackground (XtDisplay (app.w), app.gc, get_background (tmp));
    XDRAWIMAGESTRING (XtDisplay (app.w), w, app.gc,
      x * FONTSIZE, y * FONTSIZE + 23, &xbuf, 1);
    return (0);
}

int update_position (int map, int x, int y)
{
    object *op;
    int i;
    mapstruct * emap;
    int fsize;
    float dist;
    
    emap = app.list[map].emap;
    fsize = app.list[map].fontsize;

    if (fsize != FONTSIZE) {
	XClearArea (XtDisplay(app.list[map].w), XtWindow(app.list[map].w), 
		    x * fsize, y * fsize, fsize, fsize, False);
	for (i = 0, op = get_map_ob (emap, x, y); op;  i++, op = op->above);
	if (i > 0) {	    
	    dist = (fsize - FONTSIZE) / (float)i;
	    if (dist < (FONTSIZE / STACK_DEPTH))
		dist = (FONTSIZE - 1) / (float)STACK_DEPTH;
	    i--;
	    for (op = get_map_ob (emap, x, y); op; i--, op = op->above)
		if (i <= STACK_DEPTH) {
		    e_draw_object (XtWindow(app.list[map].w), 
				   (int)(i * dist) + x * fsize, 
				   (int)(i * dist) + y * fsize + FONTSIZE, op);
		    XSetForeground(XtDisplay(app.w), app.gc, 
				   discolor[0].pixel);
		    XDrawRectangle (XtDisplay(app.w), 
				    XtWindow(app.list[map].w), app.gc,
				    (int)(i * dist) + x * fsize, 
				    (int)(i * dist) + y * fsize,
				    FONTSIZE, FONTSIZE);
		}
	}
    } else {
	for (op = get_map_ob (emap, x, y); op && op->above; op = op->above);
	e_draw_object (XtWindow(app.list[map].w), 
		       x * fsize, y * fsize + FONTSIZE, op);
    }
    return (0);
}

#if 0
int e_draw_map (Window w, mapstruct * emap, int fsize)
{
    int x, y;

    for (y = 0; y < emap->mapy; y++)
	for (x = 0; x < emap->mapx; x++)
	    update_position (w, emap, x, y, fsize);
    return (0);
}
#endif

int e_draw_selection (Window w, mapstruct * emap, int x, int y)
{
    object *tmp = get_map_ob (emap, x, y);
    int i;

    while (tmp && tmp->above) {
	tmp = tmp->above;
    }

    app.look.nrof = 0;
    for (i = 0; tmp; i++, tmp = tmp->below) {
	app.look.nrof++;
	debug1 ("Drawing %s\n", tmp->name);
	draw_object (w, 0, i, tmp);
	XDrawString (XtDisplay (app.w), w, app.text_gc,
	  FONTSIZE + 8, i * FONTSIZE + 16,
	  tmp->name, strlen (tmp->name));
    }
    return (0);
}

object *get_nth_map_ob (mapstruct * emap, int x, int y, int i)
{
    object *op;

    if (!emap || out_of_map (emap, x, y))
	return (NULL);
    op = get_map_ob (emap, x, y);
    while (op && op->above)
	op = op->above;
    while (op && i-- > 0)
	op = op->below;
    return (op);
}

int e_remove_object (int map, int x, int y, int i)
{
    Window w;
    mapstruct * emap;
    object *op, *tmp;

    emap = app.list[map].emap;
    w = XtWindow(app.list[map].w);
    op = get_nth_map_ob (emap, x, y, i);

    if (op) {
	if (op->head)
	    op = op->head;
	remove_ob (op);
	debug3 ("Removing %s %i %i\n", op->name, op->x, op->y);
	for (tmp = op; tmp; tmp = tmp->more) {
	    update_position (map, tmp->x, tmp->y);
	    if (app.look.x == tmp->x && app.look.y == tmp->y)
		EdDrawLook ();
	}
	free_object (op);
    }
    return (0);
}

int find_draw_arch (mapstruct * emap, int line, archetype * at)
{
    int i;
    object *tmp;

    for (i = 0; i < 16; i++)
	if ((tmp = get_map_ob (emap, i, line)) &&
	  tmp->arch == at)
	    return (i);
    return (-1);
}

int update_wall (int map, int x, int y, int add, int rem)
{
    int i;
    object *tmp, *op;
    Window w;
    mapstruct * emap;
    
    emap = app.list[map].emap;
    w = XtWindow(app.list[map].w);

    if (out_of_map (emap, x, y) || !(op = get_map_ob (emap, x, y)))
	return (0);

    while (op->above)
	op = op->above;

    i = find_draw_arch (app.item.wall_map, app.item.wall_set, op->arch);
    if (i >= 0) {
	debug4 ("%d | %d & ~%d = %d\n", i, add, rem, (i | add) & ~rem);
	remove_ob (op);
	free_object (op);
	tmp = get_map_ob (app.item.wall_map, ((i | add) & ~rem),
	  app.item.wall_set);
	if (tmp)
	    e_insert_object (map, x, y, 0, tmp->arch);
	return (1);
    }
    return (0);
}

object *create_object (archetype * at)
{
    object *op, *prev = NULL, *head = NULL;

    while (at) {
	op = arch_to_object (at);
	op->x = at->clone.x;
	op->y = at->clone.y;
	if (head)
	    op->head = head, prev->more = op;
	if (!head)
	    head = op;
	prev = op;
	at = at->more;
    }
    return (head);
}

int insert_in_map (object * o, mapstruct * emap, int x, int y, int i)
{
    object *op, *above, *below;

    if (o->more)
	insert_in_map (o->more, emap, x, y, i);

    o->x += x;
    o->y += y;
    o->map = emap;
    UNSET_REMOVED (o);

    op = get_map_ob (emap, o->x, o->y);
    while (op && op->above)
	op = op->above;

    above = NULL;
    below = op;
    while (op && i-- > 0) {
	above = op;
	below = op = op->below;
    }

    o->below = below;
    o->above = above;

    if (above)
	above->below = o;
    if (below)
	below->above = o;
    else
	set_map_ob (emap, o->x, o->y, o);

    return (0);
}

int e_insert_object (int map, int x, int y, int i, archetype * at)
{
    Window w;
    mapstruct *emap;
    object *op;
    int j = i;

    emap = app.list[map].emap;
    w = XtWindow(app.list[map].w);
    op = get_map_ob (emap, x, y);

    /* check for duplicate object */
    while (op && op->above)
	op = op->above;
    while (op && j-- > 0)
	op = op->below;
    if (op && op->arch == at)
	return (0);

    if (arch_out_of_map (at, emap, x, y)) {
	debug0 ("Out of Map\n");
	return (0);
    }
    op = create_object (at);
    if (op && !insert_in_map (op, emap, x, y, i)) {

	debug3 ("Inserting %s %i %i\n", op->name, op->x, op->y);

	for (tmp = op; tmp; tmp = tmp->more) {
	    update_position (map, tmp->x, tmp->y);
	    if (app.look.x == tmp->x && app.look.y == tmp->y)
		EdDrawLook ();
	}
    } else {
	free_object (op);
	debug0 ("Inserting failed\n");
    }

    return (0);
}

int draw_old_list (Window w, int y, archetype ** at)
{
    int j = 0;
    for (j = 0; j < y; j++)
	if (at[j]) {
	    draw_object (w, 0, j, &(at[j]->clone));
	    XDrawString (XtDisplay (app.w), w, app.text_gc,
	      FONTSIZE + 8, j * FONTSIZE + 16,
	      at[j]->name, strlen (at[j]->name));
	}
    return (0);
}

int draw_list (Window w, int x, int y, archetype *** at)
{
    int i = 0, j = 0;
    for (j = 0; j < y; j++)
	for (i = 0; i < x; i++)
	    if (at[j][i])
		draw_object (w, i, j, &(at[j][i]->clone));
    return (0);
}

void find_colors ()
{
    int i;
    Display *dpy = XtDisplay (app.w);

    colormap = DefaultColormap (dpy, DefaultScreen (dpy));
    for (i = 0; i < 13; i++) {
	if (!XLookupColor (dpy, colormap, colorname[i], &exactcolor,
	    &discolor[i])) {
	    die ("Can't find color.");
	}
	if (!XAllocColor (dpy, colormap, &discolor[i])) {
	    die ("Can't allocate colors.");
	}
    }
}

#if 0
void init_crossfire ()
{

#ifdef DEBUG
    debug = 1;
#else
    debug = 0;
#endif

    init_vars ();
    init_archetable ();
    /* clear_arch_cache (); */
    load_archetypes ();
    empty_archetype = find_archetype ("empty_archetype");
}
#endif

int map_in_memory_p (int level)
{
    mapstruct *tmp;

    /* Have we been at this level before? */
    for (tmp = first_map; tmp; tmp = tmp->next)
	if (tmp->level == level)
	    return (1);
    return (0);
}

void efatal (char *str)
{
    debug1 ("Fatal: %s\n", str);
    exit (-1);
}

int check_level (char *name)
{
    char buf[MAX_BUF];
    struct stat statbuf;

    sprintf (buf, "%s/%s/%s.oo", LibDir, MapDir, name);
    if (stat (buf, &statbuf) || !S_ISREG (statbuf.st_mode))
	return (1);
    return (0);
}

void scroll_move_objects (mapstruct * m1, mapstruct * m2, int x, int y)
{
    int i, j;
    object *op, *tmp;

    if (x < 0)
	x += m2->mapx;
    if (y < 0)
	y += m2->mapy;

    for (i = 0; i < m1->mapx && i < m2->mapx; i++)
	for (j = 0; j < m1->mapy && j < m2->mapy; j++) {
	    while ((op = get_map_ob (m1, i, j)) && !op->head) {
		remove_ob (op);
		for (tmp = op; tmp; tmp = tmp->more) {
		    tmp->x += x;
		    tmp->y += y;
		    tmp->x %= m2->mapx;
		    tmp->y %= m2->mapy;
		}
		insert_ob_in_map (op, m2);
	    }
	}
    free_all_objects (m1);
}

