#if !defined(APPLICATION_H_)
#define APPLICATION_H_

#define Object XObject
#include <X11/X.h>
#include <Xm/Xm.h>
#undef Object

#include <objc/Object.h>

#include "UIComponent.h"
#include "MainWindow.h"

@interface Application : UIComponent
{
  Display     *_display;
  XtAppContext _appContext;
  id delegate;
  MainWindow *mainWindow;
  id windowList;
}

- init:(unsigned int *) argcp :(char**) argv;
- init:(unsigned int *) argcp :(char**) argv :(String *)fallbacks;
- makeKeyAndOrderFront: w;
- run;
- hide: sender;
- unhide: sender;
- quit: sender; 
- help: sender;
- registerWindow: w;
- appDidInit;
- delegate:del;
- delegate;
- (Display*)display;
- (int)displayWidth;
- (int)displayHeight;
- destroyAppContext;
- (Screen*)screen;

- mainWindow:o;

- registerWindow:o;
- removeFromWindowList:o;
@end

extern Application *XApp;




#include "ObjCCallback.h"




#endif
