#define Object XObject
#include <Xm/RowColumn.h>
#undef Object
#include "MenuWindow.h"
#include "MenuBar.h"
#include "CascadeButton.h"


@implementation MenuWindow


- init:(const char*)name
{
  char buffer[1024];

  [super init:name];
  sprintf(buffer,"%sMenuBar",name);
  menuBar = [[MenuBar alloc] init:buffer parent:_main];
  [super menuBar:menuBar];
  return self;
}

- menuBar
{
  return menuBar;
}

- helpButton:b
{
  XtVaSetValues([menuBar baseWidget],XmNmenuHelpWidget,[b baseWidget],NULL);
  return self;
}

- helpButton
{
  return [menuBar helpButton];

//  id hb=[[CascadeButton alloc] init:"helpButton" parent:[menuBar baseWidget]];
//  [self helpButton:hb];
//  return hb;
}


- addMenuItem:m xname:(const char*)n  // these return the menu button, pass the menu button to add to
{
  if(m==self) return [menuBar addMenuItem:menuBar xname:n];
  else return [menuBar addMenuItem:m xname:n];
}

- addSubMenuItem:m xname:(const char*)n
{
  if(m==self) return [menuBar addSubMenuItem:menuBar xname:n];
  else return [menuBar addSubMenuItem:m xname:n];
} 
   
- addItem:m
{ 
  if(m==self) return [menuBar addItem:menuBar];
  else return [menuBar addItem:m];
}

- addSeparatorItem:m
{
  if(m==self) return [menuBar addSeparatorItem:menuBar];
  else return [menuBar addSeparatorItem:m];
}



@end
