
/*
** Copyright 1993 by Bruno Pages
**
** Permission to use, copy, and distribute for non-commercial purposes,
** is hereby granted without fee, providing that the above copyright
** notice appear in all copies and that both the copyright notice and this
** permission notice appear in supporting documentation.
** The software may be modified for your own purposes, but modified versions
** may not be distributed.
** This software is provided "as is" without any expressed or implied warranty.
**
**
*/


#ifndef _Object_h
#define _Object_h


/* Objet permet de memoriser tous les types predefinis
   d'objet dont la taille est <= sizeof(void *) c'est a
   dire tous dans le cas actuel.

   A priori Object devrait donc etre une union,
   malheureusement certain compilateur generent
   des codes absurdes lorsque l'on utilise les unions,
   par exemple dans le cas suivant :

		typedef union {
		  int Int;
		} Object;

		Object f(i)
		     int   i;
		{
		  Object result;
		
		  result.Int = i;

		  return result;
		}

   le compilateur officiel pour SUN4 genere un appel fonctionnel
   (a `.stret4') alors qu'il n'y a rien a faire puisque l'on a
   sizeof(Object) == sizeof(int) !
   Le compilateur GNU ne s'egare pas ainsi. mais tous le monde
   ne l'a pas, aussi Object sera un int ou un long suivant les cas,
   sa definition etant faite par word.c */

#include "word.h"

#endif
