/***********************************************************
Copyright 1993 by Ove Kalkan

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#ifndef _XslIconB_h
#define _XslIconB_h

/***********************************************************************
 *
 * Icon Widget
 *
 ***********************************************************************/

#include <X11/Xaw/Simple.h>

/* Resources:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		Pixel		XtDefaultBackground
 border		     BorderColor	Pixel		XtDefaultForeground
 borderWidth	     BorderWidth	Dimension	1
 cursor		     Cursor		Cursor		None
 cursorName	     Cursor		String		NULL
 destroyCallback     Callback		XtCallbackList	NULL
 height		     Height		Dimension	0
 insensitiveBorder   Insensitive	Pixmap		Gray
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 pointerColor	     Foreground		Pixel		XtDefaultForeground
 pointerColorBackground Background	Pixel		XtDefaultBackground
 sensitive	     Sensitive		Boolean		True
 width		     Width		Dimension	0
 x		     Position		Position	0
 y		     Position		Position	0

 image		     Pixmap		Pixmap		None
 shape		     Pixmap		Pixmap		None
 simage		     Pixmap		Pixmap		None
 sshape		     Pixmap		Pixmap		None
 imageWidth	     Width		Dimension	0
 imageHeight	     Height		Dimension	0
*/

#define	XtNimage	"image"
#define	XtNshape	"shape"
#define	XtNsimage	"simage"
#define	XtNsshape	"sshape"
#define	XtNimageWidth	"imageWidth"
#define	XtNimageHeight	"imageHeight"

#define	XtNhighlightThickness "highlightThickness"

/* Class record constants */

extern WidgetClass iconBWidgetClass;

typedef struct _IconBClassRec *IconBWidgetClass;
typedef struct _IconBRec      *IconBWidget;

#endif /* _XslIcon_h */
/* DON'T ADD STUFF AFTER THIS #endif */
